package edu.uoc.characterbuilder.controller;

import java.util.List;
import java.util.Map;

import javax.inject.Inject;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import edu.uoc.characterbuilder.ejb.LogEJBLocal;
import edu.uoc.characterbuilder.model.LogJPA;

@Controller
public class GeneralController {

	@Inject
	private LogEJBLocal log;
	
	@RequestMapping(value="/mainView", method=RequestMethod.GET)
	public String mainView(Map<String, Object> model) {
		
		List<LogJPA> logList = log.getLog();
		
		model.put("logList", logList);
		
		return "views/mainView";
	}

	@RequestMapping(value="/login", method=RequestMethod.GET)
	public String indexPage(@RequestParam(required = false) String authfailed, String logout, Map<String, Object> model) {
		if (authfailed != null) {  
			model.put("message", "Wrong username and/or password");
		} else if (logout != null) {  
			model.put("message", "Log out succesfull");  
		}
		return "views/login";
	}
	
}
