package edu.uoc.characterbuilder.ejb;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.ejb.Local;

import edu.uoc.characterbuilder.model.CharacterJPA;

@Local
public interface CharacterEJBLocal {

	public List<CharacterJPA> getAccessibleCharactersByUserName(String user);
	public void deleteCharacterById(int id) throws org.springframework.transaction.UnexpectedRollbackException;
	public void updateRights(HashMap<String, Object> accessRights) throws org.springframework.transaction.UnexpectedRollbackException;
	public CharacterJPA getCharacterById(int id) throws javax.persistence.NoResultException;
	public void makeUserOwner(Map<String,Object> data);
	public void saveNewCharacter(Map<String, Object> newCharacterData) throws org.springframework.transaction.UnexpectedRollbackException;
	public List<String> validateCharacter(Map<String, Object> newCharacterData);
	public void saveUpdatedCharacter(Map<String, Object> newCharacterData) throws org.springframework.transaction.UnexpectedRollbackException;
	public Map<String,Object> getUpdatedElementsLists(List<Integer> chosenQuirks);
	public List<String> validateCharacterJPA(CharacterJPA character);
	
}
