package edu.uoc.characterbuilder.ejb;

import java.util.Calendar;
import java.util.Date;
import java.util.List;

import javax.ejb.Stateless;
import javax.inject.Named;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;

import org.springframework.transaction.annotation.Transactional;

import edu.uoc.characterbuilder.model.LogJPA;

@Named
@Stateless
public class LogEJB implements LogEJBLocal {

	@PersistenceContext(unitName = "characterBuilderPU")
	private EntityManager entman;
	
	@Override
	public List<LogJPA> getLog() {
		
		clearLog(10);
		
		List<LogJPA> logList = entman.createQuery("from LogJPA order by logdate desc", LogJPA.class).getResultList();
		
		return logList;
	}

	@Override
	@Transactional
	public void insertLog(String description) {
		
		LogJPA log = new LogJPA(new Date(), description);
		
		entman.persist(log);
		
	}

	@Override
	@Transactional
	public void clearLog(int days) {
		
		Calendar c = Calendar.getInstance();
		c.add(Calendar.DAY_OF_YEAR, -days);
		Date d = c.getTime();

		entman.createQuery("delete from LogJPA l where l.logdate < ?").setParameter(1, d);
		
	}

}
