package edu.uoc.characterbuilder.model;

import java.io.Serializable;
import java.util.List;
import java.util.Set;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import com.fasterxml.jackson.annotation.JsonIgnore;

@Entity
@Table(name="abilitycategory",schema="characterbuilder")
public class AbilityCategoryJPA implements Serializable {

	private static final long serialVersionUID = 1L;
	
	@SequenceGenerator(name="abilitycategory_id_seq",sequenceName="characterbuilder.abilitycategory_id_seq", allocationSize=1)
	@GeneratedValue(generator="abilitycategory_id_seq",strategy=GenerationType.SEQUENCE)
	@Id
	private int id;
	private String name;
	@OneToMany(cascade = CascadeType.ALL, fetch = FetchType.EAGER ,mappedBy="abilityCategory")
	@JsonIgnore
	private Set<AbilityJPA> abilities;
	
	@OneToMany(fetch = FetchType.EAGER, cascade = CascadeType.ALL, mappedBy="dependentAbilityCategoryJPA")
	@JsonIgnore
	private Set<AbilityCategoryQuirkJPA> requiredQuirks;

	protected AbilityCategoryJPA() {
		super();
	}

	public AbilityCategoryJPA(String name) {
		super();
		this.name = name;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public Set<AbilityJPA> getAbilities() {
		return abilities;
	}

	public void setAbilities(Set<AbilityJPA> abilities) {
		this.abilities = abilities;
	}

	public Set<AbilityCategoryQuirkJPA> getRequiredQuirks() {
		return requiredQuirks;
	}

	public void setRequiredQuirks(Set<AbilityCategoryQuirkJPA> requiredQuirks) {
		this.requiredQuirks = requiredQuirks;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		AbilityCategoryJPA other = (AbilityCategoryJPA) obj;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "Ability category " + name;
	}
	
}
