package edu.uoc.characterbuilder.model;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import com.fasterxml.jackson.annotation.JsonIgnore;

@Entity
@Table(name="abilitycategory_quirk",schema="characterbuilder")
public class AbilityCategoryQuirkJPA implements Serializable {

	private static final long serialVersionUID = 1L;

	@SequenceGenerator(name="abilitycategory_quirk_id_seq",sequenceName="characterbuilder.abilitycategory_quirk_id_seq", allocationSize=1)
	@GeneratedValue(generator="abilitycategory_quirk_id_seq",strategy=GenerationType.SEQUENCE)
	@Id
	@JsonIgnore
	private int id;
	@ManyToOne
	@JoinColumn(name = "id_quirk",referencedColumnName = "id")
	private QuirkJPA requiredQuirkJPA;
	@ManyToOne
	@JoinColumn(name = "id_abilitycategory", referencedColumnName = "id")
	private AbilityCategoryJPA dependentAbilityCategoryJPA;
	private boolean negated;
	
	protected AbilityCategoryQuirkJPA() {
		super();
	}

	public AbilityCategoryQuirkJPA(QuirkJPA requiredQuirkJPA,
			AbilityCategoryJPA dependentAbilityCategoryJPA, boolean negated) {
		super();
		this.requiredQuirkJPA = requiredQuirkJPA;
		this.dependentAbilityCategoryJPA = dependentAbilityCategoryJPA;
		this.negated = negated;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public QuirkJPA getRequiredQuirkJPA() {
		return requiredQuirkJPA;
	}

	public void setRequiredQuirkJPA(QuirkJPA requiredQuirkJPA) {
		this.requiredQuirkJPA = requiredQuirkJPA;
	}

	public AbilityCategoryJPA getDependentAbilityCategoryJPA() {
		return dependentAbilityCategoryJPA;
	}

	public void setDependentAbilityCategoryJPA(
			AbilityCategoryJPA dependentAbilityCategoryJPA) {
		this.dependentAbilityCategoryJPA = dependentAbilityCategoryJPA;
	}

	public boolean isNegated() {
		return negated;
	}

	public void setNegated(boolean negated) {
		this.negated = negated;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime
				* result
				+ ((dependentAbilityCategoryJPA == null) ? 0
						: dependentAbilityCategoryJPA.hashCode());
		result = prime
				* result
				+ ((requiredQuirkJPA == null) ? 0 : requiredQuirkJPA.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		AbilityCategoryQuirkJPA other = (AbilityCategoryQuirkJPA) obj;
		if (dependentAbilityCategoryJPA == null) {
			if (other.dependentAbilityCategoryJPA != null)
				return false;
		} else if (!dependentAbilityCategoryJPA
				.equals(other.dependentAbilityCategoryJPA))
			return false;
		if (requiredQuirkJPA == null) {
			if (other.requiredQuirkJPA != null)
				return false;
		} else if (!requiredQuirkJPA.equals(other.requiredQuirkJPA))
			return false;
		return true;
	}
	
}
