package edu.uoc.characterbuilder.model;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import com.fasterxml.jackson.annotation.JsonIgnore;

@Entity
@Table(name="ability_quirk",schema="characterbuilder")
public class AbilityQuirkJPA implements Serializable {

	private static final long serialVersionUID = 1L;

	@SequenceGenerator(name="ability_quirk_id_seq",sequenceName="characterbuilder.ability_quirk_id_seq", allocationSize=1)
	@GeneratedValue(generator="ability_quirk_id_seq",strategy=GenerationType.SEQUENCE)
	@Id
	@JsonIgnore
	private int id;
	@ManyToOne
	@JoinColumn(name = "id_quirk",referencedColumnName = "id")
	private QuirkJPA requiredQuirkJPA;
	@ManyToOne
	@JoinColumn(name = "id_ability", referencedColumnName = "id")
	private AbilityJPA dependentAbilityJPA;
	private boolean negated;
	
	protected AbilityQuirkJPA() {
		super();
	}

	public AbilityQuirkJPA(QuirkJPA requiredQuirkJPA,
			AbilityJPA dependentAbilityJPA, boolean negated) {
		super();
		this.requiredQuirkJPA = requiredQuirkJPA;
		this.dependentAbilityJPA = dependentAbilityJPA;
		this.negated = negated;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public QuirkJPA getRequiredQuirkJPA() {
		return requiredQuirkJPA;
	}

	public void setRequiredQuirkJPA(QuirkJPA requiredQuirkJPA) {
		this.requiredQuirkJPA = requiredQuirkJPA;
	}

	public AbilityJPA getDependentAbilityJPA() {
		return dependentAbilityJPA;
	}

	public void setDependentAbilityJPA(AbilityJPA dependentAbilityJPA) {
		this.dependentAbilityJPA = dependentAbilityJPA;
	}

	public boolean isNegated() {
		return negated;
	}

	public void setNegated(boolean negated) {
		this.negated = negated;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime
				* result
				+ ((dependentAbilityJPA == null) ? 0 : dependentAbilityJPA
						.hashCode());
		result = prime
				* result
				+ ((requiredQuirkJPA == null) ? 0 : requiredQuirkJPA.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		AbilityQuirkJPA other = (AbilityQuirkJPA) obj;
		if (dependentAbilityJPA == null) {
			if (other.dependentAbilityJPA != null)
				return false;
		} else if (!dependentAbilityJPA.equals(other.dependentAbilityJPA))
			return false;
		if (requiredQuirkJPA == null) {
			if (other.requiredQuirkJPA != null)
				return false;
		} else if (!requiredQuirkJPA.equals(other.requiredQuirkJPA))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "AbilityQuirkJPA [requiredQuirkJPA=" + requiredQuirkJPA
				+ ", dependentAbilityJPA=" + dependentAbilityJPA + ", negated="
				+ negated + "]";
	}
	
}
