package edu.uoc.characterbuilder.model;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import com.fasterxml.jackson.annotation.JsonIgnore;

@Entity
@Table(name="ability_character",schema="characterbuilder")
public class CharacterAbilityJPA implements Serializable {

	private static final long serialVersionUID = 1L;

	@SequenceGenerator(name="ability_character_id_seq",sequenceName="characterbuilder.ability_character_id_seq", allocationSize=1)
	@GeneratedValue(generator="ability_character_id_seq",strategy=GenerationType.SEQUENCE)
	@Id
	@JsonIgnore
	private int id;
	@ManyToOne
	@JoinColumn(name = "id_ability",referencedColumnName = "id")
	private AbilityJPA abilityJPA;
	@JsonIgnore
	@ManyToOne
	@JoinColumn(name = "id_character", referencedColumnName = "id")
	private CharacterJPA characterJPA;
	private int infancyInvestedXps;
	private int adultInvestedXps;
	
	protected CharacterAbilityJPA() {
		super();
	}

	public CharacterAbilityJPA(AbilityJPA abilityJPA,
			CharacterJPA characterJPA, int infancyInvestedXps,
			int adultInvestedXps) {
		super();
		this.abilityJPA = abilityJPA;
		this.characterJPA = characterJPA;
		this.infancyInvestedXps = infancyInvestedXps;
		this.adultInvestedXps = adultInvestedXps;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public AbilityJPA getAbilityJPA() {
		return abilityJPA;
	}

	public void setAbilityJPA(AbilityJPA abilityJPA) {
		this.abilityJPA = abilityJPA;
	}

	public CharacterJPA getCharacterJPA() {
		return characterJPA;
	}

	public void setCharacterJPA(CharacterJPA characterJPA) {
		this.characterJPA = characterJPA;
	}

	public int getInfancyInvestedXps() {
		return infancyInvestedXps;
	}

	public void setInfancyInvestedXps(int infancyInvestedXps) {
		this.infancyInvestedXps = infancyInvestedXps;
	}

	public int getAdultInvestedXps() {
		return adultInvestedXps;
	}

	public void setAdultInvestedXps(int adultInvestedXps) {
		this.adultInvestedXps = adultInvestedXps;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((abilityJPA == null) ? 0 : abilityJPA.hashCode());
		result = prime * result
				+ ((characterJPA == null) ? 0 : characterJPA.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		CharacterAbilityJPA other = (CharacterAbilityJPA) obj;
		if (abilityJPA == null) {
			if (other.abilityJPA != null)
				return false;
		} else if (!abilityJPA.equals(other.abilityJPA))
			return false;
		if (characterJPA == null) {
			if (other.characterJPA != null)
				return false;
		} else if (!characterJPA.equals(other.characterJPA))
			return false;
		return true;
	}
	
}
