package edu.uoc.characterbuilder.model;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

@Entity
@Table(name="log",schema="characterbuilder")
public class LogJPA implements Serializable {
	
	private static final long serialVersionUID = 1L;
	@SequenceGenerator(name="log_id_seq",sequenceName="characterbuilder.log_id_seq", allocationSize=1)
	@GeneratedValue(generator="log_id_seq",strategy=GenerationType.SEQUENCE)
	@Id
	private int id;
	private Date logdate;
	private String description;
	
	protected LogJPA() {
		super();
	}

	public LogJPA(Date logdate, String description) {
		super();
		this.logdate = logdate;
		this.description = description;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public Date getLogdate() {
		return logdate;
	}

	public void setLogdate(Date logdate) {
		this.logdate = logdate;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + id;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		LogJPA other = (LogJPA) obj;
		if (id != other.id)
			return false;
		return true;
	}	

}
