package edu.uoc.characterbuilder.model;

import java.io.Serializable;
import java.util.List;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.OneToMany;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import com.fasterxml.jackson.annotation.JsonIgnore;

@Entity
@Table(name="quirkcategory",schema="characterbuilder")
public class QuirkCategoryJPA implements Serializable {

	private static final long serialVersionUID = 1L;
	@SequenceGenerator(name="quirkcategory_id_seq",sequenceName="characterbuilder.quirkcategory_id_seq", allocationSize=1)
	@GeneratedValue(generator="quirkcategory_id_seq",strategy=GenerationType.SEQUENCE)
	@Id
	private int id;
	private String name;
	@OneToMany(cascade = CascadeType.ALL, fetch = FetchType.EAGER )
	@JoinTable(name="quirkcategory_quirk",schema="characterbuilder",
		      joinColumns={@JoinColumn(name="id_quirkcategory", referencedColumnName="id")},
		      inverseJoinColumns={@JoinColumn(name="id_quirk", referencedColumnName="id")})
	@JsonIgnore
	private List<QuirkJPA> quirks;
	
	protected QuirkCategoryJPA() {

	}

	public QuirkCategoryJPA(String name) {
		super();
		this.name = name;
	}
	
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public List<QuirkJPA> getQuirks() {
		return quirks;
	}
	public void setQuirks(List<QuirkJPA> quirks) {
		this.quirks = quirks;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + id;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		QuirkCategoryJPA other = (QuirkCategoryJPA) obj;
		if (id != other.id)
			return false;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return "Quirk category " + name;
	}
	
}
