package edu.uoc.characterbuilder.model;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import com.fasterxml.jackson.annotation.JsonIgnore;

@Entity
@Table(name="quirk_quirk",schema="characterbuilder")
public class QuirkQuirkJPA implements Serializable {

	private static final long serialVersionUID = 1L;
	@SequenceGenerator(name="quirk_quirk_id_seq",sequenceName="characterbuilder.quirk_quirk_id_seq", allocationSize=1)
	@GeneratedValue(generator="quirk_quirk_id_seq",strategy=GenerationType.SEQUENCE)
	@Id
	@JsonIgnore
	private int id;
	@ManyToOne
	@JoinColumn(name = "id_required_quirk",referencedColumnName = "id")
	private QuirkJPA requiredQuirkJPA;
	@ManyToOne
	@JoinColumn(name = "id_dependent_quirk", referencedColumnName = "id")
	private QuirkJPA dependentQuirkJPA;
	private boolean negated;
	
	
	protected QuirkQuirkJPA() {

	}

	public QuirkQuirkJPA(boolean negated, QuirkJPA requiredQuirkJPA,
			QuirkJPA dependentQuirkJPA) {
		super();
		this.negated = negated;
		this.requiredQuirkJPA = requiredQuirkJPA;
		this.dependentQuirkJPA = dependentQuirkJPA;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public boolean isNegated() {
		return negated;
	}

	public void setNegated(boolean negated) {
		this.negated = negated;
	}

	public QuirkJPA getRequiredQuirkJPA() {
		return requiredQuirkJPA;
	}

	public void setRequiredQuirkJPA(QuirkJPA requiredQuirkJPA) {
		this.requiredQuirkJPA = requiredQuirkJPA;
	}

	public QuirkJPA getDependentQuirkJPA() {
		return dependentQuirkJPA;
	}

	public void setDependentQuirkJPA(QuirkJPA dependentQuirkJPA) {
		this.dependentQuirkJPA = dependentQuirkJPA;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime
				* result
				+ ((dependentQuirkJPA == null) ? 0 : dependentQuirkJPA
						.hashCode());
		result = prime
				* result
				+ ((requiredQuirkJPA == null) ? 0 : requiredQuirkJPA.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		QuirkQuirkJPA other = (QuirkQuirkJPA) obj;
		if (dependentQuirkJPA == null) {
			if (other.dependentQuirkJPA != null)
				return false;
		} else if (!dependentQuirkJPA.equals(other.dependentQuirkJPA))
			return false;
		if (requiredQuirkJPA == null) {
			if (other.requiredQuirkJPA != null)
				return false;
		} else if (!requiredQuirkJPA.equals(other.requiredQuirkJPA))
			return false;
		return true;
	}
	
}
