package edu.uoc.characterbuilder.model;

import java.io.Serializable;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

@Entity
@Table(name="role",schema="characterbuilder")
public class RoleJPA implements Serializable {
	
	private static final long serialVersionUID = 1L;
	@SequenceGenerator(name="role_id_seq",sequenceName="characterbuilder.role_id_seq", allocationSize=1)
	@GeneratedValue(generator="role_id_seq",strategy=GenerationType.SEQUENCE)
	@Id
	private int id;
	private String name;
	
	protected RoleJPA(){

	}
	
	public RoleJPA(String name) {
		super();
		this.name = name;
	}
	public int getId() {
		return id;
	}
	public void setId(int id) {
		this.id = id;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		RoleJPA other = (RoleJPA) obj;
		if (name == null) {
			if (other.name != null)
				return false;
		} else if (!name.equals(other.name))
			return false;
		return true;
	}

}
