package edu.uoc.characterbuilder.model;

import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.ManyToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

import com.fasterxml.jackson.annotation.JsonIgnore;

@Entity
@Table(name="user_character",schema="characterbuilder")
public class UserCharacterJPA implements Serializable {

	private static final long serialVersionUID = 1L;

	@SequenceGenerator(name="user_character_id_seq",sequenceName="characterbuilder.user_character_id_seq", allocationSize=1)
	@GeneratedValue(generator="user_character_id_seq",strategy=GenerationType.SEQUENCE)
	@Id
	@JsonIgnore
	private int id;
	@ManyToOne
	@JoinColumn(name = "id_user",referencedColumnName = "id")
	@JsonIgnore
	private UserJPA userJPA;
	@ManyToOne
	@JoinColumn(name = "id_character", referencedColumnName = "id")
	private CharacterJPA characterJPA;
	@Column(name = "owner")
	private boolean owner;
	@Column(name = "canread")
	private boolean canRead;
	@Column(name = "canwrite")
	private boolean canWrite;
	
	protected UserCharacterJPA() {

	}

	public UserCharacterJPA(UserJPA userJPA, CharacterJPA characterJPA,
			boolean owner, boolean canRead, boolean canWrite) {
		super();
		this.userJPA = userJPA;
		this.characterJPA = characterJPA;
		this.owner = owner;
		this.canRead = canRead;
		this.canWrite = canWrite;
	}

	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public UserJPA getUserJPA() {
		return userJPA;
	}

	public void setUserJPA(UserJPA userJPA) {
		this.userJPA = userJPA;
	}

	public CharacterJPA getCharacterJPA() {
		return characterJPA;
	}

	public void setCharacterJPA(CharacterJPA characterJPA) {
		this.characterJPA = characterJPA;
	}

	public boolean isOwner() {
		return owner;
	}

	public void setOwner(boolean owner) {
		this.owner = owner;
	}

	public boolean isCanRead() {
		return canRead;
	}

	public void setCanRead(boolean canRead) {
		this.canRead = canRead;
	}

	public boolean isCanWrite() {
		return canWrite;
	}

	public void setCanWrite(boolean canWrite) {
		this.canWrite = canWrite;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((characterJPA == null) ? 0 : characterJPA.hashCode());
		result = prime * result + ((userJPA == null) ? 0 : userJPA.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		UserCharacterJPA other = (UserCharacterJPA) obj;
		if (characterJPA == null) {
			if (other.characterJPA != null)
				return false;
		} else if (!characterJPA.equals(other.characterJPA))
			return false;
		if (userJPA == null) {
			if (other.userJPA != null)
				return false;
		} else if (!userJPA.equals(other.userJPA))
			return false;
		return true;
	}
	
}
