var modeEdition;

$(document).ready(function() {
	
	//Botons per plegar les seccions de virttus i defectes
	
	$(".toggleButton").on("click", function() {
		$(this).toggleClass("folded").toggleClass("unfolded");
		$(this).siblings(".quirksTable").slideToggle("fast");
	});
	
	//Boto de nou element
	
	$('#newElementButton').bind('click',function(event){
		$('#mainViewContainer').hide();
		$('#formEditCreateContainer').show();
		$('#mainForm fieldset legend').text('New ability');
		modeEdition = false;
	});
	
	//Boto per cancelar la vista i tornar a la principal
	
	$('#cancelViewButton').bind('click',function(event){
		window.location = linkMainView;
	});
	
	//Link a la llista d'elements per esborrar
	
	$(".deleteElementLink").on("click", function() {
		var idElement = $(this).siblings("input[type=hidden]").val();
		deleteElement(idElement);
	});
	
	//Link a la llista d'elements per editar
	
	$(".editElementLink").on("click", function() {
		var idElement = $(this).siblings("input[type=hidden]").val();
		getElementBtId(idElement);
		$('#mainForm fieldset legend').text('Update ability');
		$('#mainViewContainer').hide();
		$('#formEditCreateContainer').show();
		modeEdition = true;
	});
	
	//Formulari de edicio i creacio
	
	//Si el checkbox de seleccionat no està marcat, desactiva el checkbox vei de "negacio" i vice-versa 
	$("input[type=checkbox].selected").change(function() {
	    if(this.checked) {
	        $(this).siblings(".negated").removeClass("greyed");
	        $(this).siblings("input[type=checkbox].negated").removeAttr("disabled");
	    } else {
	    	$(this).siblings(".negated").addClass("greyed");
	    	$(this).siblings("input[type=checkbox].negated").attr("disabled", true).prop("checked", false);
	    }
	});
	
	$("#cancelFormButton").bind('click',function(event){
		resetForm($('#mainForm'));
		$('#mainForm .negated').addClass("greyed");
		$('#mainViewContainer').show();
		$('#formEditCreateContainer').hide();
	});
	
	$("#saveFormButton").bind('click',function(event){
		var formFields = $('#mainForm').find('textarea, select, input[type=checkbox], input[type=hidden], input[type=text]');
		
		var errorList = validateFields(formFields);

		if(errorList.length > 0){
			openModalErrorDialog('Error validating fields',errorList);
		} else {
			
				if(modeEdition){
				
					$('#dialog').html('<p>Are you sure you want to save this ability?</p>').prop('title','Please confirm:');
		
					$("#dialog").dialog({
						modal: true,
						autoOpen: true,
						width:'auto',
						buttons: {
							"Continue": function() {
								ajaxSaveOrUpdateElement (formFields);
								$(this).dialog("close");	
							},
							"Cancel": function() {
								$(this).dialog("close");
							}
						}
					});
					
				} else {
					
					ajaxSaveOrUpdateElement (formFields);
					
				}
		}
	});
	
});

//Recuperar categoria de la BD

function getElementBtId(idElement) {
	
	var request = $.ajax({
		type: "POST",
		url: linkGetElement,
		data: "id=" + idElement,
		dataType: "json"
	});

	request.done(function(data) {
		prepareFormForEdit(data);
	});

	request.fail(function(jqXHR, textStatus) {
		openModalErrorDialog('Error','Database error');
	});
}

//Esborrat

function deleteElement(idElement){
	
	$('#dialog').html('<p>Are you sure you want to delete this ability?</p>').prop('title','Please confirm:');
	
	$("#dialog").dialog({
		modal: true,
		autoOpen: false,
		buttons: {
			"Continue": function() {
				ajaxDeleteElement(idElement);
				$(this).dialog("close");	
			},
			"Cancel": function() {
				$(this).dialog("close");
			}
		}
	});
	$("#dialog").dialog("open");
};

function ajaxDeleteElement(idElement){
	
	var request = $.ajax({
		type: "POST",
		url: linkDeleteElement,
		data: "id=" + idElement,
		dataType: "json"
	});

	request.done(function(data) {
		switch (data.error) {
			case "none":
				$('#ability' + idElement).remove();
	        break;
			case "notEmpty":
				var dependentAbilities ="";
				$(data.abilities).each(function(index){
					dependentAbilities += this.name + '<br />';
				});
				openModalErrorDialog('Error','Category ' + $('#element' + idElement + ' .columnName').text() + ' has elements : <br />' + dependentAbilities);
	        break;
			default:
				openModalErrorDialog('Error','Database error');
		        break
		}
	});

	request.fail(function(jqXHR, textStatus) {
		openModalErrorDialog('Error','Database error');
	});
};

//Creacio

function ajaxSaveOrUpdateElement (formFields){

var datavars = $(formFields).filter('textarea, select, #infancySelectable, input[type=text],input[type=hidden]');
	
	var datacheckboxesSelected = $(formFields).filter('input[type=checkbox].selected:checked');
	var datacheckboxesNegated = $(formFields).filter('input[type=checkbox].negated:checked');
	
	var data = {
		requiredQuirks: []
	};

	$(datavars).each(function(index){

		if($(this).is(':checkbox')){
			data[$(this).attr('name')] = $(this).prop('checked');
		} else {
			data[$(this).attr('name')] = $(this).val();
		}
		
	});
	
	$(datacheckboxesSelected).each(function(index){

		var selectedCheckBox = $(this);
		var result = $.grep(datacheckboxesNegated, function(e){ return e.name == selectedCheckBox.attr('name')});
		
		var jsonVariable = {};
		
		jsonVariable["id"] = selectedCheckBox.attr('name');
		jsonVariable["negated"] = result.length > 0;
		
		data.requiredQuirks.push(jsonVariable);
		
	});
	
	var link = (modeEdition === true) ? linkUpdateElement : linkSaveNewElement;
	
	var request = $.ajax({
			type: "POST",
			url: link,
			data: JSON.stringify(data),
			contentType: "application/json; charset=utf-8",
			async: false,
            cache: false,          
            processData:false
		});
		
		request.done(function(data) {
			if (data.error != 'none'){
				openModalErrorDialog('Error',data.error);
			} else {
				if(!modeEdition){
					$('#dialog').html('<p>Ability created succesfully</p>').prop('title','Information');
					
					$("#dialog").dialog({
						modal: true,
						autoOpen: true
					});
				}
				
				window.location = linkElementView;
			}
		});
		
		request.fail(function(jqXHR, textStatus) {
			openModalErrorDialog('Error','Database error');
		});
	
	}

function prepareFormForEdit(data){

	var ability = data.ability;
	var requiredQuirks = $(data.requiredQuirks);
	
	$("#id").val(ability.id);
	$("#name").val(ability.name);
	$("#description").val(ability.description);
	$("#selectAbilityCategory").val(ability.abilityCategory.id);
	$('#infancySelectable').prop('checked',ability.infancySelectable);
	
	requiredQuirks.each(function(index){
		$('#sel' + this.requiredQuirkJPA.id).removeAttr("disabled").prop('checked',true);
		$('#neg' + this.requiredQuirkJPA.id).removeClass("greyed").removeAttr("disabled");
		$('#neg' + this.requiredQuirkJPA.id).siblings('span').removeClass("greyed");
		if(this.negated == true){
			$('#neg' + this.requiredQuirkJPA.id).prop('checked',true);
		}
		
	});
}