var modeEdition;

$(document).ready(function() {
	
	$('#newElementButton').bind('click',function(event){
		$('#mainViewContainer').hide();
		$('#formEditCreateContainer').show();
		$('#mainForm fieldset legend').text('New category');
		modeEdition = false;
	});
	
	$('#cancelViewButton').bind('click',function(event){
		window.location = linkCancel;
	});
	
	$(".editElementLink").on("click", function() {
		var idElement = $(this).siblings("input[type=hidden]").val();
		getElementBtId(idElement);
		$('#mainForm fieldset legend').text('Update category');
		$('#mainViewContainer').hide();
		$('#formEditCreateContainer').show();
		modeEdition = true;
	});
	
	$(".deleteElementLink").on("click", function() {
		var idElement = $(this).siblings("input[type=hidden]").val();
		deleteElement(idElement);
	});
	
	//Formulari de edicio i creacio
	
	$("#cancelFormButton").bind('click',function(event){
		resetForm($('#mainForm'));
		$('#mainViewContainer').show();
		$('#formEditCreateContainer').hide();
	});
	
	$("#saveFormButton").bind('click',function(event){
		var formFields = $('#mainForm').find('input[type=hidden], input[type=text],input[type=password]');
		var errorList = validateFields(formFields);

		if(errorList.length > 0){
			openModalErrorDialog('Error validating fields',errorList);
		} else {		
			if(modeEdition){
				
				$('#dialog').html('<p>Are you sure you want to save this category?</p>').prop('title','Please confirm:');

				$("#dialog").dialog({
					modal: true,
					autoOpen: true,
					width:'auto',
					open:{},
					buttons: {
						"Continue": function() {
							ajaxSaveOrUpdateElement (formFields)
							$(this).dialog("close");	
						},
						"Cancel": function() {
							$(this).dialog("close");
						}
					}
				});
				
			} else {
				ajaxSaveOrUpdateElement (formFields)
			}

		}
	});
	
});

//Recuperar categoria de la BD

function getElementBtId(idElement) {
	
	var request = $.ajax({
		type: "POST",
		url: linkGetElement,
		data: "id=" + idElement,
		dataType: "json"
	});

	request.done(function(data) {
		$("#id").val(data.id);
		$("#name").val(data.name);
	});

	request.fail(function(jqXHR, textStatus) {
		openModalErrorDialog('Error','Database error');
	});
}

//Esborrat de categories

function deleteElement(idElement){
	
	$('#dialog').html('<p>Are you sure you want to delete this category?</p>').prop('title','Please confirm:');
	
	$("#dialog").dialog({
		modal: true,
		autoOpen: true,
		buttons: {
			"Continue": function() {
				ajaxDeleteElement(idElement);
				$(this).dialog("close");	
			},
			"Cancel": function() {
				$(this).dialog("close");
			}
		}
	});
};

function ajaxDeleteElement(idElement){
	
	var request = $.ajax({
		type: "POST",
		url: linkDeleteElement,
		data: "id=" + idElement,
		dataType: "json"
	});

	request.done(function(data) {
		if(data.result == 'correct'){
			$('#element' + idElement).remove();
		} else {
			var dependentQirks ="";
			$(data.quirks).each(function(index){
				dependentQirks += this.quirkType + ' ' + this.quirkDivision + '<br />' + this.name + '<br />';
			});
			openModalErrorDialog('Error','Category ' + $('#element' + idElement + ' .columnName').text() + ' has elements : <br />' + dependentQirks);
		};
	});

	request.fail(function(jqXHR, textStatus) {
		openModalErrorDialog('Error','Database error');
	});
};

//Creacio  i edicio de categories

function ajaxSaveOrUpdateElement (formFields){

	var dataVars = formFields.serialize();
	
	var link = (modeEdition === true) ? linkUpdateElement : linkSaveNewElement;
	
	var request = $.ajax({
			type: "POST",
			url: link,
			data: dataVars,
			dataType: "json"
		});
		
		request.done(function(data) {
			if (data.error != 'none'){
				openModalErrorDialog('Error',data.error);
			} else {
				if(!modeEdition){
					$('#dialog').html('<p>Quirk category created succesfully</p>').prop('title','Information');
					
					$("#dialog").dialog({
						modal: true,
						autoOpen: true,
						buttons:{},
						   open: function(event, ui){
							     setTimeout("$('#dialog').dialog('close')",1000);
							    }
					});
				}
				rebuildElementList(data.elements);
				formFields.val("");
				$('#mainViewContainer').show();
				$('#formEditCreateContainer').hide();
			}
		});
		
		request.fail(function(jqXHR, textStatus) {
			openModalErrorDialog('Error','Database error');
		});		
	
}

function rebuildElementList(newList){

	var newContent = '<li class="lineTitle"><span class="columnTitle columnName">Name</span></li>';
	
	$(newList).each(function(index){
		newContent += '<li id="element' + this.id + '" class="elementLine">';
		newContent += '<span class="columnName">' + this.name + '</span>';
		newContent += '<a class ="editElementLink" href="#"><img src="' + editElementIconLink + '" alt="Edit quirkCategory" title="Edit quirk category"/></a>';
		newContent += '<a class ="deleteElementLink" href="#"><img src="' + deleteElementIconLink + '" alt="Delete quirkCategory" title="Delete quirk category"/></a>';
		newContent += '<input type="hidden" value="' + this.id + '"/></li>';		
	});

	$('#elementsTable').html(newContent);
	
	//Cal tornar a associar els events a les icones
	
	$(".deleteElementLink").on("click", function() {
		var idElement = $(this).next("input[type=hidden]").val();
		deleteElement(idElement);
	});
	
	$(".editElementLink").on("click", function() {
		var idElement = $(this).siblings("input[type=hidden]").val();
		getElementBtId(idElement);
		$('#mainForm fieldset legend').text('Update category');
		$('#mainViewContainer').hide();
		$('#formEditCreateContainer').show();
		modeEdition = true;
	});
	
}