var modeEdition;

$(document).ready(function() {
	
	$(".toggleButton").on("click", function() {
		$(this).toggleClass("folded").toggleClass("unfolded");
		$(this).siblings(".quirksTable").slideToggle("fast");
	});
	
	
	$('#newElementButton').bind('click',function(event){
		$('#mainViewContainer').hide();
		$('#formEditCreateContainer').show();
		$('#leftBlock legend').text('New Quirk');
		modeEdition = false;
	});
	
	$('#cancelViewButton').bind('click',function(event){
		window.location = linkCancel;
	});
	
	$(".editElementLink").on("click", function() {
		var idElement = $(this).siblings("input[type=hidden]").val();
		getElementBtId(idElement);
		//S'amaga aquest element de la llista per a que no se puguin crear referencies cirqulars. La solucio ideal seria separar-ho en pantalles apart
		//per a garantir la seguretat pero com que se supos que aixo nomes ho fara servir un administrador...
		$('#quirkRight' + idElement).toggle();
		$('#mainForm fieldset legend').text('Update category');
		$('#mainViewContainer').hide();
		$('#formEditCreateContainer').show();
		modeEdition = true;
	});
	
	$(".deleteElementLink").on("click", function() {
		var idElement = $(this).siblings("input[type=hidden]").val();
		deleteElement(idElement);
	});
	
	//Formulari de edicio i creacio
	
	
	//Si el checkbox de seleccionat no està marcat, desactiva el checkbox vei de "negacio" i vice-versa 
	$("input[type=checkbox].selected").change(function() {
	    if(this.checked) {
	        $(this).siblings(".negated").removeClass("greyed");
	        $(this).siblings("input[type=checkbox].negated").removeAttr("disabled");
	    } else {
	    	$(this).siblings(".negated").addClass("greyed");
	    	$(this).siblings("input[type=checkbox].negated").attr("disabled", true).prop("checked", false);
	    }
	});
	
	$("#cancelFormButton").bind('click',function(event){
		$('#quirkRight' + $('#id').val()).toggle();
		resetForm($('#mainForm'));
		$('#mainForm .negated').addClass("greyed");
		$('#mainViewContainer').show();
		$('#formEditCreateContainer').hide();
	});
	
	$("#saveFormButton").bind('click',function(event){

		var formFields = $('#mainForm').find('textarea, select, input[type=checkbox], input[type=hidden], input[type=text]');
		
		var errorList = validateFields(formFields);

		if(errorList.length > 0){
			openModalErrorDialog('Error validating fields',errorList);
		} else {
			
			if(modeEdition){
			
				$('#dialog').html('<p>Are you sure you want to save this quirk?</p>').prop('title','Please confirm:');

				$("#dialog").dialog({
					modal: true,
					autoOpen: true,
					width:'auto',
					buttons: {
						"Continue": function() {
							ajaxSaveOrUpdateElement (formFields)
							$(this).dialog("close");	
						},
						"Cancel": function() {
							$(this).dialog("close");
						}
					}
				});
				
			} else {
				ajaxSaveOrUpdateElement (formFields)
			}
		}
	});
	
});

//Recuperar element de la BD

function getElementBtId(idElement) {
	
	var request = $.ajax({
		type: "POST",
		url: linkGetElement,
		data: "id=" + idElement,
		dataType: "json"
	});

	request.done(function(data) {
		prepareFormForEdit(data);
	});

	request.fail(function(jqXHR, textStatus) {
		openModalErrorDialog('Error','Database error');
	});
}

//Esborrat

function deleteElement(idElement){
	
	var request = $.ajax({
		type: "POST",
		url: linkGetElement,
		data: "id=" + idElement,
		dataType: "json"
	});

	request.done(function(data) {

		var text = "Are you sure you want to delete this quirk?";
		
		var dependentsQuirks = $(data.dependentQuirk);
		var dependentsAbilityCategories = $(data.dependentAbilityCategory);
		var dependentsAbilities = $(data.dependentAbility);
		
		if (dependentsQuirks.size() > 0 || dependentsAbilityCategories.size() > 0 || dependentsAbilities.size() > 0){
			
			text += "<br />This quirk is requirement of:<br />";
			
			dependentsQuirks.each(function(index){
				
				text += this.dependentQuirkJPA.quirkType + " " + this.dependentQuirkJPA.quirkDivision + " - " + this.dependentQuirkJPA.name + "<br />";  	
				
			});
			
			dependentsAbilityCategories.each(function(index){
				
				text += "Ability category: " + this.dependentAbilityCategoryJPA.name + "<br />";  	
				
			});
			
			dependentsAbilities.each(function(index){
				
				text += "Ability: " + this.dependentAbilityJPA.name + " - category: " + this.dependentAbilityJPA.abilityCategory.name + "<br />"; 	
				
			});
			
		}		
		
		$('#dialog').html('<p>' + text + '</p>').prop('title','Please confirm:');
		
		$("#dialog").dialog({
			modal: true,
			autoOpen: true,
			width:'auto',
			buttons: {
				"Continue": function() {
					ajaxDeleteElement(data);
					$(this).dialog("close");	
				},
				"Cancel": function() {
					$(this).dialog("close");
				}
			}
		});

	});

	request.fail(function(jqXHR, textStatus) {
		openModalErrorDialog('Error','Database error');
	});
	
};

function ajaxDeleteElement(element){
	
	var request = $.ajax({
		type: "POST",
		url: linkDeleteElement,
		data: "id=" + element.quirk.id,
		dataType: "json"
	});

	request.done(function(data) {
		if(data.result == 'correct'){
			$('#quirkLeft' + element.quirk.id).remove();
			$('#quirkRight' + element.quirk.id).remove();
		} else {
			openModalErrorDialog('Error','Error deleting ' + element.quirk.quirkType + ' ' + element.quirk.quirkDivision + ' ' + element.quirk.name);
		};
	});

	request.fail(function(jqXHR, textStatus) {
		openModalErrorDialog('Error','Database error');
	});
};

//Creacio i edicio

function ajaxSaveOrUpdateElement (formFields){

	var datavars = $(formFields).filter('textarea, select, input[type=text],input[type=hidden]');
	
	var datacheckboxesSelected = $(formFields).filter('input[type=checkbox].selected:checked');
	var datacheckboxesNegated = $(formFields).filter('input[type=checkbox].negated:checked');
	
	var data = {
		requiredQuirks: []
	};

	$(datavars).each(function(index){

		data[$(this).attr('name')] = $(this).val();
		
	});
	
	$(datacheckboxesSelected).each(function(index){

		var selectedCheckBox = $(this);
		var result = $.grep(datacheckboxesNegated, function(e){ return e.name == selectedCheckBox.attr('name')});
		
		var jsonVariable = {};
		
		jsonVariable["id"] = selectedCheckBox.attr('name');
		jsonVariable["negated"] = result.length > 0;
		
		data.requiredQuirks.push(jsonVariable);
		
	});
	
	var link = (modeEdition === true) ? linkUpdateElement : linkSaveNewElement;
	
	var request = $.ajax({
			type: "POST",
			url: link,
			data: JSON.stringify(data),
			contentType: "application/json; charset=utf-8",
			async: false,
            cache: false,          
            processData:false
		});
		
		request.done(function(data) {
			if (data.error != 'none'){
				openModalErrorDialog('Error',data.error);
			} else {
				if(!modeEdition){
					$('#dialog').html('<p>Quirk created succesfully</p>').prop('title','Information');
					
					$("#dialog").dialog({
						modal: true,
						autoOpen: true
					});
				}
				window.location = linkQuirksView;
			}
		});
		
		request.fail(function(jqXHR, textStatus) {
			openModalErrorDialog('Error','Database error');
		});		
	
}

function prepareFormForEdit(data){

	var quirk = data.quirk;
	var requiredQuirks = $(data.requiredQuirks);
	
	$("#id").val(quirk.id);
	$("#name").val(quirk.name);
	$("#selectDivision").val(quirk.quirkDivision);
	$("#selectType").val(quirk.quirkType);
	$("#selectQuirkCategory").val(quirk.quirkCategory.id);
	$("#description").val(quirk.description);
	
	requiredQuirks.each(function(index){
		$('#sel' + this.requiredQuirkJPA.id).removeAttr("disabled").prop('checked',true);
		$('#neg' + this.requiredQuirkJPA.id).removeClass("greyed").removeAttr("disabled");
		$('#neg' + this.requiredQuirkJPA.id).siblings('span').removeClass("greyed");
		if(this.negated == true){
			$('#neg' + this.requiredQuirkJPA.id).prop('checked',true);
		}
		
	});
}