$(document).ready(function() {
	
	$('#newUserButton').bind('click',function(event){
		$('#mainViewContainer').hide();
		$('#formEditCreateContainer').show();
	});
	
	$('#cancelViewButton').bind('click',function(event){
		window.location = linkCancel;
	});
	
	$(".deleteUserLink").on("click", function() {
		var idUser = $(this).next("input[type=hidden]").val();
		deleteUser(idUser);
	});
	
	//Formulari de creacio de jugadors
	
	$("#cancelFormButton").bind('click',function(event){
		$('#mainViewContainer').show();
		$('#formEditCreateContainer').hide();
	});
	
	$("#saveFormButton").bind('click',function(event){
		var formFields = $('#mainForm').find('input[type=text],input[type=password]');
		var errorList = validateFields(formFields);

		if($('#password').val() != $('#reppassword').val()){
			errorList += "New password and repeat password fields are not equal.";
		}
		
		if(errorList.length > 0){
			openModalErrorDialog('Error validating fields',errorList);
		} else {
			ajaxSaveUser(formFields);
		}
	});
	
});

//Esborrat d'usuaris

function deleteUser(idUser){
	
	$('#dialog').html('<p>Are you sure you want to delete this user?</p>').prop('title','Please confirm:');
	
	$("#dialog").dialog({
		modal: true,
		autoOpen: true,
		buttons: {
			"Continue": function() {
				$(this).dialog("close");	
				ajaxDeleteUser(idUser);
			},
			"Cancel": function() {
				$(this).dialog("close");
			}
		}
	});
};

function ajaxDeleteUser(idUser){
	
	var request = $.ajax({
		type: "POST",
		url: linkDeleteUser,
		data: "id=" + idUser,
		dataType: "text"
	});

	request.done(function(result) {
		if(result == 'correct'){
			$('#element' + idUser).remove();
		} else {
			openModalErrorDialog('Error','Error deleting user : ' + $('#element' + idUser + ' .columnName').text());
		};
	});

	request.fail(function(jqXHR, textStatus) {
		openModalErrorDialog('Error','Database error');
	});
};

//Creacio d'usuaris

function ajaxSaveUser(formFields){

	var dataVars = formFields.serialize();
	
	var request = $.ajax({
			type: "POST",
			url: linkSaveNewUser,
			data: dataVars,
			dataType: "json"
		});
		
		request.done(function(data) {
			if (data.error != 'none'){
				openModalErrorDialog('Error',data.error);
			} else {
				
				$('#dialog').html('<p>User created succesfully</p>').prop('title','Information');
				
				$("#dialog").dialog({
					modal: true,
					autoOpen: true,
					buttons:{},
					   open: function(event, ui){
						     setTimeout("$('#dialog').dialog('close')",1000);
						    }
				});
				
				rebuildUserList(data.players);
				formFields.val("");
				$('#mainViewContainer').show();
				$('#formEditCreateContainer').hide();
			}
		});
		
		request.fail(function(jqXHR, textStatus) {
			openModalErrorDialog('Error','Database error');
		});		
	
}

function rebuildUserList(newList){

	var newContent = '<li class="lineTitle"><span class="columnTitle columnName">Name</span><span class="columnTitle columnEmail">Email</span></li>';
	
	$(newList).each(function(index){
		newContent += '<li id="element' + this.id + '" class="elementLine">';
		newContent += '<span class="columnName">' + this.username + '</span>';
		newContent += '<span class="columnEmail">' + this.email + '</span>';
		newContent += '<a class ="editUserLink" href="' + editUserLink + '?username=' + this.username + '"><img src="' + editUserIconLink + '" alt="Edit user" title="Edit user"/></a>';
		newContent += '<a class ="deleteUserLink" href="#" ><img src="' + deleteUserIconLink + '" alt="Delete user" title="Delete user"/></a>';
		newContent += '<input type="hidden" value="' + this.id + '"/></li>';		
	});

	$('#usersTable').html(newContent);
	
	//Cal tornar a associar els events a les icones
	
	$(".deleteUserLink").on("click", function() {
		var idUser = $(this).next("input[type=hidden]").val();
		deleteUser(idUser);
	});
	
}