<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<!DOCTYPE html>
<html>
	<head>
		<%@ include file="../../fragments/links.jspf" %>
		<link href="<c:url value='/css/abilityCategory.css'/>" rel="stylesheet" type="text/css" media="screen" />
		<script type="text/javascript" src="<c:url value='/webcontent/admin/js/abilityCategory.js'/>"></script>
	</head>
	<body>
		<script>
			var linkGetElement = '<c:url value="/admin/getAbilityCategory" />';
			var linkSaveNewElement = '<c:url value="/admin/saveNewAbilityCategory" />';
			var linkUpdateElement = '<c:url value="/admin/updateAbilityCategory" />';
			var linkDeleteElement = '<c:url value="/admin/deleteAbilityCategory" />';
			var linkElementView = '<c:url value="/admin/abilityCategories" />';
			var linkMainView = '<c:url value="/mainView" />';
		</script>
		<%@ include file="../../fragments/header.jspf" %>
		<%@ include file="../../fragments/navBar.jspf" %>
		<%@ include file="../../fragments/errorModalDialog.jspf" %>
 		<div class="modalDialog" id="dialog">
		</div>
		<div id="mainContainer">
			<div id="mainViewContainer">
				<fieldset>
					<legend>Ability categories</legend>
					<ul class="elementsTable" id="elementsTable">
						<li class="lineTitle"><span class="columnTitle columnName">Name</span></li>
						<c:forEach items="${AbilitycategoryList}" var="element">
							<li id="element${element.id}" class="elementLine">
								<span class="columnName">${element.name}</span>
								<a class ="editElementLink" href="#" >
									<img src="<c:url value='/img/buttons/edit.png' />" alt="Edit quirkCategory" title="Edit quirk category"/>
								</a>
								<a class ="deleteElementLink" href="#">
									<img src="<c:url value='/img/buttons/delete.png' />" alt="Delete quirkCategory" title="Delete quirkCategory"/>
								</a>
								<input type="hidden" value="${element.id}"/>
							</li>
						</c:forEach>
					</ul>
				</fieldset>	
				<div id="lineButtons">
					<button id="newElementButton" type="button">New category...</button>
					<button id="cancelViewButton" type="button">Cancel</button>
				</div>
			</div>
			<div id="formEditCreateContainer">
				<form id="mainForm">
					<input id="id" name="id" type="hidden" value="${quirk.id}"/>
					<div id="leftBlock">
						<fieldset id="quirkData">
							<legend></legend>
							<div class="line">
								<div class="label">
									<label for="name">Name</label>
								</div> 
								<div class="field">
									<input id="name" name="name" type="text" maxlength="25" data-required="true"/><span class="required-field">*</span>
								</div>
							</div>
							<span class="required-field-definition">* : Required fields</span>
						</fieldset>
						<div id="lineButtons">
							<button id="saveFormButton" type="button">Save</button>
							<button id="cancelFormButton" type="button">Cancel</button>
						</div>
					</div>
					<div id="rightBlock">
						<div class="dataBlock">
							<div class="toggleButton unfolded" ></div><p class="titleBlock">Required Virtues</p>
							<ul class="quirksTable quirkCategoryTable" id="rightVirtuesTable">
								<c:forEach items="${categoryList}" var="category">
									<li class="categoryLine">
										<div class="toggleButton unfolded" ></div>
										<span class="categoryName columnName">${category.name}</span>
										<ul class="quirksTable">								
											<c:forEach items="${category.quirks}" var="quirk">
												<c:if test="${quirk.quirkDivision == 'VIRTUE'}">
													<li id="quirkRight${quirk.id}" class="quirkLine">
														<div class="formQuirkLine">
															<div class="formQuirkCheckboxes">
																<span>Selected</span>
																<input id="sel${quirk.id}" type="checkbox" class="selected" name="${quirk.id}">
																<span class="negated greyed">Negated</span>
																<input id="neg${quirk.id}" type="checkbox" class="negated" disabled="disabled" name="${quirk.id}">
															</div>
															<div class="formQuirkData">
																<span class="formQuirkLineData columnName">${quirk.name}</span>
																<span class="formQuirkLineData columnType">${quirk.quirkType}</span>
															</div>
														</div>
													</li>
												</c:if>
											</c:forEach>						
										</ul>
									</li>
								</c:forEach>
							</ul>
						</div>
						<div class="dataBlock">
							<div class="toggleButton unfolded" ></div><p class="titleBlock">Required Flaws</p>
							<ul class="quirksTable quirkCategoryTable" id="rightFlawsTable">
								<c:forEach items="${categoryList}" var="category">
									<li class="categoryLine">
										<div class="toggleButton unfolded" ></div>
										<span class="categoryName columnName">${category.name}</span>
										<ul class="quirksTable">								
											<c:forEach items="${category.quirks}" var="quirk">
												<c:if test="${quirk.quirkDivision == 'FLAW'}">
													<li id="quirkRight${quirk.id}" class="quirkLine">
														<div class="formQuirkLine">
															<div class="formQuirkCheckboxes">
																<span>Selected</span>
																<input id="sel${quirk.id}" type="checkbox" class="selected" name='${quirk.id}'>
																<span class="negated greyed">Negated</span>
																<input id="neg${quirk.id}" type="checkbox" class="negated greyed" disabled="disabled" name='${quirk.id}'>
															</div>
															<div class="formQuirkData">
																<span class="formQuirkLineData columnName">${quirk.name}</span>
																<span class="formQuirkLineData columnType">${quirk.quirkType}</span>
															</div>
														</div>
													</li>
												</c:if>
											</c:forEach>						
										</ul>
									</li>
								</c:forEach>
							</ul>
						</div>
					</div>
				</form>
			</div>
    	</div>
  	</body>
</html>