<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<!DOCTYPE html>
<html>
	<head>
		<%@ include file="../../fragments/links.jspf" %>
		<link href="<c:url value='/css/quirkCategory.css'/>" rel="stylesheet" type="text/css" media="screen" />
		<script type="text/javascript" src="<c:url value='/webcontent/admin/js/quirkCategory.js'/>"></script>
	</head>
	<body>
		<script>
			var linkGetElement = '<c:url value="/admin/getQuirkCategory" />';
			var linkSaveNewElement = '<c:url value="/admin/saveNewQuirkCategory" />';
			var linkUpdateElement = '<c:url value="/admin/updateQuirkCategory" />';
			var linkDeleteElement = '<c:url value="/admin/deleteQuirkCategory" />';
			var linkCancel = '<c:url value="/mainView" />';
			
			var editElementIconLink = '<c:url value="/img/buttons/edit.png" />';
			var deleteElementIconLink = '<c:url value="/img/buttons/delete.png" />';
		</script>
		<%@ include file="../../fragments/header.jspf" %>
		<%@ include file="../../fragments/navBar.jspf" %>
		<%@ include file="../../fragments/errorModalDialog.jspf" %>
 		<div class="modalDialog" id="dialog" title="">
		</div>
		<div id="mainContainer">
			<div id="mainViewContainer">
				<fieldset>
					<legend>Quirk categories</legend>
					<ul class="elementsTable" id="elementsTable">
						<li class="lineTitle"><span class="columnTitle columnName">Name</span></li>
						<c:forEach items="${categoryList}" var="element">
							<li id="element${element.id}" class="elementLine">
								<span class="columnName">${element.name}</span>
								<a class ="editElementLink" href="#" >
									<img src="<c:url value='/img/buttons/edit.png' />" alt="Edit quirkCategory" title="Edit quirk category"/>
								</a>
								<a class ="deleteElementLink" href="#">
									<img src="<c:url value='/img/buttons/delete.png' />" alt="Delete quirkCategory" title="Delete quirk category"/>
								</a>
								<input type="hidden" value="${element.id}"/>
							</li>
						</c:forEach>
					</ul>
				</fieldset>	
				<div id="lineButtons">
					<button id="newElementButton" type="button">New category...</button>
					<button id="cancelViewButton" type="button">Cancel</button>
				</div>
			</div>
			<div id="formEditCreateContainer">
				<form id="mainForm">
					<fieldset>
						<legend></legend>
						<div class="line">
							<div class="label">
								<label for="name">Name</label>
							</div> 
							<div class="field">
								<input id="name" name="name" type="text" maxlength="25" data-required="true"/><span class="required-field">*</span>
							</div>
						</div>
					<span class="required-field-definition">* : Required fields</span>
					</fieldset>
					<div id="lineButtons">
						<button id="saveFormButton" type="button">Save</button>
						<button id="cancelFormButton" type="button">Cancel</button>
					</div>
					<input id="id" name="id" type="hidden" />
				</form>
			</div>
    	</div>
  	</body>
</html>