<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<!DOCTYPE html>
<html>
	<head>
		<%@ include file="../../fragments/links.jspf" %>
		<script type="text/javascript" src="<c:url value='/webcontent/admin/js/quirks.js'/>"></script>
		<link href="<c:url value='/css/quirks.css'/>" rel="stylesheet" type="text/css" media="screen" />
	</head>
	<body>
		<script>
			var linkGetElement = '<c:url value="/admin/getQuirk" />';
			var linkSaveNewElement = '<c:url value="/admin/saveNewQuirk" />';
			var linkUpdateElement = '<c:url value="/admin/updateQuirk" />';
			var linkDeleteElement = '<c:url value="/admin/deleteQuirk" />';
			var linkQuirksView = '<c:url value="/admin/quirks" />';
			var linkCancel = '<c:url value="/mainView" />';
		</script>
		<%@ include file="../../fragments/header.jspf" %>
		<%@ include file="../../fragments/navBar.jspf" %>
		<%@ include file="../../fragments/errorModalDialog.jspf" %>
 		<div class="modalDialog" id="dialog">
		</div>
		<div id="mainContainer">
			<div id="mainViewContainer">
					<div class="dataBlock" id="virtuesSection">
						<div class="toggleButton unfolded" ></div><p class="titleBlock">Virtues</p>
						<ul class="quirksTable quirkCategoryTable" id="leftVirtuesTable">
							<c:forEach items="${categoryList}" var="category">
								<li class="categoryLine">
									<div class="toggleButton unfolded" ></div>
									<span class="categoryName columnName">${category.name}</span>
									<ul class="quirksTable">								
										<c:forEach items="${category.quirks}" var="quirk">
											<c:if test="${quirk.quirkDivision == 'VIRTUE'}">
												<li id="quirkLeft${quirk.id}" class="quirkLine">
													<span class="columnName">${quirk.name}</span>
													<span class="columnType">${quirk.quirkType}</span>
													<div class="lineLinks">
														<a class ="editElementLink" href="#" >
															<img src="<c:url value='/img/buttons/edit.png' />" alt="Edit virtue" title="Edit virtue"/>
														</a>
														<a class ="deleteElementLink" href="#">
															<img src="<c:url value='/img/buttons/delete.png' />" alt="Delete virtue" title="Delete virtue"/>
														</a>
														<input type="hidden" value="${quirk.id}"/>
													</div>
												</li>
											</c:if>
										</c:forEach>						
									</ul>
								</li>
							</c:forEach>
						</ul>
					</div>
					<div class="dataBlock" id="flawsSection">
						<div class="toggleButton unfolded" ></div><p class="titleBlock">Flaws</p>
						<ul class="quirkCategoryTable quirksTable" id="leftFlawsTable">
							<c:forEach items="${categoryList}" var="category">
								<li class="categoryLine">
									<div class="toggleButton unfolded" ></div>
									<span class="categoryName columnName">${category.name}</span>
									<ul class="quirksTable">								
										<c:forEach items="${category.quirks}" var="quirk">
											<c:if test="${quirk.quirkDivision == 'FLAW'}">
												<li id="quirkLeft${quirk.id}" class="quirkLine">
													<span class="columnName">${quirk.name}</span>
													<span class="columnType">${quirk.quirkType}</span>
													<div class="lineLinks">
														<a class ="editElementLink" href="#" >
															<img src="<c:url value='/img/buttons/edit.png' />" alt="Edit flaw" title="Edit flaw"/>
														</a>
														<a class ="deleteElementLink" href="#">
															<img src="<c:url value='/img/buttons/delete.png' />" alt="Delete flaw" title="Delete flaw"/>
														</a>
														<input type="hidden" value="${quirk.id}"/>
													</div>
												</li>
											</c:if>
										</c:forEach>						
									</ul>
								</li>
							</c:forEach>
						</ul>
					</div>
				<div id="lineButtons">
					<button id="newElementButton" type="button">New quirk...</button>
					<button id="cancelViewButton" type="button">Cancel</button>
				</div>
			</div>
			<div id="formEditCreateContainer">
				<form id="mainForm">
					<input id="id" name="id" type="hidden" value="${quirk.id}"/>
					<div id="leftBlock">
						<fieldset id="quirkData">
							<legend></legend>
							<div class="line">
								<div class="label">
									<label for="name">Name</label>
								</div> 
								<div class="field">
									<input id="name" name="name" type="text" maxlength="24" data-required="true"/><span class="required-field">*</span>
								</div>
							</div>
							<div class="boxSelect">
								<select id="selectDivision" name="quirkDivision" data-required="true">
									<option selected value="-1">Choose kind</option>
									<option value="VIRTUE">Virtue</option>
									<option value="FLAW">Flaw</option>
								</select>
								<span class="required-field">*</span>
								<select id="selectType" name="quirkType" data-required="true">
									<option selected value="-1">Choose type</option>
									<option value="MAJOR">Major</option>
									<option value="MINOR">Minor</option>
								</select>
								<span class="required-field">*</span>
								<select id="selectQuirkCategory" name="quirkCategory" data-required="true">
									<option selected value="-1">Choose category</option>
									<c:forEach items="${categoryList}" var="category">
										<option value="${category.id}">${category.name}</option>
									</c:forEach>
								</select>
								<span class="required-field">*</span>
							</div>
							<div class="descriptionField">
								<span class="">Description</span>
								<textarea id="description" name="description"cols="52" rows="4"></textarea>
							</div>
							<span class="required-field-definition">* : Required fields</span>
						</fieldset>
						<div id="lineButtons">
							<button id="saveFormButton" type="button">Save</button>
							<button id="cancelFormButton" type="button">Cancel</button>
						</div>
					</div>
					<div id="rightBlock">
						<div class="dataBlock editionDatablock">
							<div class="toggleButton unfolded" ></div><p class="titleBlock">Required Virtues</p>
							<ul class="quirksTable quirkCategoryTable" id="rightVirtuesTable">
								<c:forEach items="${categoryList}" var="category">
									<li class="categoryLine">
										<div class="toggleButton unfolded" ></div>
										<span class="categoryName columnName">${category.name}</span>
										<ul class="quirksTable">								
											<c:forEach items="${category.quirks}" var="quirk">
												<c:if test="${quirk.quirkDivision == 'VIRTUE'}">
													<li id="quirkRight${quirk.id}" class="quirkLine">
														<div class="formQuirkLine">
															<div class="formQuirkCheckboxes">
																<span>Selected</span>
																<input id="sel${quirk.id}" type="checkbox" class="selected" name="${quirk.id}">
																<span class="negated greyed">Negated</span>
																<input id="neg${quirk.id}" type="checkbox" class="negated" disabled="disabled" name="${quirk.id}">
															</div>
															<div class="formQuirkData">
																<span class="formQuirkLineData columnName">${quirk.name}</span>
																<span class="formQuirkLineData columnTypeEdition">${quirk.quirkType}</span>
															</div>
														</div>
													</li>
												</c:if>
											</c:forEach>						
										</ul>
									</li>
								</c:forEach>
							</ul>
						</div>
						<div class="dataBlock editionDatablock">
							<div class="toggleButton unfolded" ></div><p class="titleBlock">Required Flaws</p>
							<ul class="quirksTable quirkCategoryTable" id="rightFlawsTable">
								<c:forEach items="${categoryList}" var="category">
									<li class="categoryLine">
										<div class="toggleButton unfolded" ></div>
										<span class="categoryName columnName">${category.name}</span>
										<ul class="quirksTable">								
											<c:forEach items="${category.quirks}" var="quirk">
												<c:if test="${quirk.quirkDivision == 'FLAW'}">
													<li id="quirkRight${quirk.id}" class="quirkLine">
														<div class="formQuirkLine">
															<div class="formQuirkCheckboxes">
																<span>Selected</span>
																<input id="sel${quirk.id}" type="checkbox" class="selected" name='${quirk.id}'>
																<span class="negated greyed">Negated</span>
																<input id="neg${quirk.id}" type="checkbox" class="negated greyed" disabled="disabled" name='${quirk.id}'>
															</div>
															<div class="formQuirkData">
																<span class="formQuirkLineData columnName">${quirk.name}</span>
																<span class="formQuirkLineData columnTypeEdition">${quirk.quirkType}</span>
															</div>
														</div>
													</li>
												</c:if>
											</c:forEach>						
										</ul>
									</li>
								</c:forEach>
							</ul>
						</div>
					</div>
				</form>
			</div>
    	</div>
  	</body>
</html>