<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<!DOCTYPE html>
<html>
	<head>
		<%@ include file="../../fragments/links.jspf" %>
		<link href="<c:url value='/css/userManagement.css'/>" rel="stylesheet" type="text/css" media="screen" />
		<script type="text/javascript" src="<c:url value='/webcontent/admin/js/userManagement.js'/>"></script>
	</head>
	<body>
		<script>
			var linkSaveNewUser = '<c:url value="/admin/saveNewUser" />';
			var linkDeleteUser = '<c:url value="/admin/deleteUser" />';
			var linkCancel = '<c:url value="/mainView" />';
			
			var editUserLink = '<c:url value="/editUser" />';
			var editUserIconLink = '<c:url value="/img/buttons/edit.png" />';
			var deleteUserIconLink = '<c:url value="/img/buttons/delete.png" />';
		</script>
		<%@ include file="../../fragments/header.jspf" %>
		<%@ include file="../../fragments/navBar.jspf" %>
		<%@ include file="../../fragments/errorModalDialog.jspf" %>
 		<div class="modalDialog" id="dialog">
		</div>
		<div id="mainContainer">
			<div id="mainViewContainer">
				<fieldset>
					<legend>User management</legend>
					<ul class="elementsTable" id="usersTable">
						<li class="lineTitle"><span class="columnTitle columnName">Name</span><span class="columnTitle columnEmail">Email</span></li>
						<c:forEach items="${userList}" var="user">
							<li id="element${user.id}" class="elementLine">
								<span class="columnName">${user.username}</span>
								<span class="columnEmail">${user.email}</span>
								<a class ="editUserLink" href="<c:url value="/editUser?username=${user.username}"/>">
									<img src="<c:url value='/img/buttons/edit.png' />" alt="Edit user" title="Edit user"/>
								</a>
								<a class ="deleteUserLink" href="#">
									<img src="<c:url value='/img/buttons/delete.png' />" alt="Delete user" title="Delete user"/>
								</a>
								<input type="hidden" value="${user.id}" />
							</li>
						</c:forEach>
					</ul>
				</fieldset>	
				<div id="lineButtons">
					<button id="newUserButton" type="button">New user...</button>
					<button id="cancelViewButton" type="button">Cancel</button>
				</div>
			</div>
			<div id="formEditCreateContainer">
				<form id="mainForm">
					<fieldset>
						<legend>New User</legend>
						<div class="line">
							<div class="label">
								<label for="username">Username</label>
							</div> 
							<div class="field">
								<input id="username" name="username" type="text" value="${user.username}" maxlength="25" data-required="true"/><span class="required-field">*</span>
							</div>
						</div>
						<div class="line">
							<div class="label">
								<label for="password">Password</label>
							</div>
							<div class="field"> 
								<input id="password" name="password" value="" type="password" maxlength="12" data-required="true"/><span class="required-field">*</span>
							</div>
						</div>
						<div class="line">
							<div class="label">
								<label for="reppassword">Repeat password</label>
							</div>
							<div class="field"> 
								<input id="reppassword" value="" type="password" maxlength="12" data-required="true"/><span class="required-field">*</span>
							</div>
						</div>
						<div class="line">
							<div class="label">
								<label for="email">Email</label>
							</div> 
							<div class="field">
								<input id="email" name="email" type="text" value="${user.email}" maxlength="25" data-validation="email" data-required="true"/><span class="required-field">*</span>
							</div>
						</div>
					<span class="required-field-definition">* : Required fields</span>
					</fieldset>
					<div id="lineButtons">
						<button id="saveFormButton" type="button">Save</button>
						<button id="cancelFormButton" type="button">Cancel</button>
					</div>
				</form>
			</div>
    	</div>
  	</body>
</html>