var mode;

var childhoodXps = 0;
var adulthoodXps = 0;
var previousChildhoodSum = 0;
var previousAdulthoodSum = 0;

$(document).ready(function() {
	
	//Boto de nou personatge
	
	$('#newElementButton').bind('click',function(event){
		$('#mainViewContainer').hide();
		$('#tabs').show();
		mode = 'creation';
	});
	
	//Link a editar el personatge a la llista de personatges per esborrar
	
	$(".editElementLink").on("click", function() {
		var idElement = $(this).siblings("input[type=hidden]").val();
		mode = 'edition';
		getElementBtId(idElement);
		$('#mainViewContainer').hide();
		$('#tabs').show();
	});
	
	//Link per visualitzar el personatge a la llista de personatges per esborrar
	
	$(".viewElementLink").on("click", function() {
		var idElement = $(this).siblings("input[type=hidden]").val();
		mode = 'viewing';
		getElementBtId(idElement);
		$('#mainViewContainer').hide();
		$('#tabs').show();
	});
	
	//Boto per cancelar la vista de personatges i tornar a la principal
	
	$('#cancelViewButton').bind('click',function(event){
		window.location = linkMainView;
	});
	
	//Link a esborrar el personatge a la llista de personatges per esborrar
	
	$(".deleteElementLink").on("click", function() {
		var idElement = $(this).siblings("input[type=hidden]").val();
		deleteElement(idElement);
	});
	
	//Link per editar els permisos d'accés a la llista de personatges per esborrar
	
	$(".updateAccessLink").on("click", function() {
		var idElement = $(this).siblings("input[type=hidden]").val();
		getDataEditAccessform(idElement);
		$('#mainViewContainer').hide();
		$('#formEditAccessContainer').show();
	});
	
	//Formulari d'edicio de permisos
	
	$('#cancelRightsViewButton').on("click", function() {
		$('#mainViewContainer').show();
		$('#formEditAccessContainer').hide();
		$('#usersTable').empty();
	});
	
	$('#saveRightsViewButton').on("click", function() {
		var userLines = $('#mainAccessForm').find('li.elementLine');
		var characterId = $('#characterId').val();
		
		$('#dialog').html('<p>Are you sure you want to update this character acces rights?</p>').prop('title','Please confirm:');

		$("#dialog").dialog({
			modal: true,
			autoOpen: true,
			width:'auto',
			buttons: {
				"Continue": function() {
					ajaxUpdateUserRights(characterId, userLines);
					$(this).dialog("close");	
				},
				"Cancel": function() {
					$(this).dialog("close");
				}
			}
		});
	});
	
	//Elements de Jquery UI del formulari d'edicio de personatges
	
	 $( "#tabs" ).tabs();
	 
	//Spinners de les característiques
	 
	 $('.spinnerChar').spinner({ 
		 min: -3, 
		 max: 3,
		 stop: function(event, ui) {
			 updateCharPoints();
		    }
		 });

	 $('#spinnerAge').spinner({ 
		 min: 16,
		 numberFormat: "n",
		 spin: function(event, ui) {
			 var sum = totalSpentXps($('.habAdult'));
			 var value = $(this).spinner( "value" );
			 if(((ui.value - 5) * 15) < sum ){
				 event.preventDefault();
			 }
		    },
		 stop: function(event, ui) {
			 var sum = totalSpentXps($('.habAdult'));
			 adulthoodXps = (($('#spinnerAge').spinner("value") - 5) * 15);
			 $('#adulthoodFreeXps').val(adulthoodXps - sum);
		    }
		 });
	 
	 $('.habChild').on('change',function(e){
		 var element = $(this);

		 if($.isNumeric(element.val()) && Math.floor(element.val()) == element.val()){
			 
			 var newValue = parseInt(element.val());
			 var oldValue = parseInt(element.data('oldvalue'));
			 var sum = totalSpentXps($('.habChild'));

			//Si el total de punts gastats es major que el nombre de punts disponibles
			 if(sum > childhoodXps){
				 previousChildhoodSum = childhoodXps;
				 element.val(oldValue + parseInt($('#childhoodFreeXps').val()));
				 $('#childhoodFreeXps').val(0);
			 } else {
				 previousChildhoodSum = sum;
				 element.data('oldvalue',newValue);
				 $('#childhoodFreeXps').val(childhoodXps - sum);
			 }
			 updateTotalScore(element.data('id'));
		 } else {
			 element.val(0);
			 element.trigger('change');
		 }
		});
	 
	 $('.habAdult').on('change',function(e){
		 var element = $(this);

		 if($.isNumeric(element.val()) && Math.floor(element.val()) == element.val()){
			 
			 var newValue = parseInt(element.val());
			 var oldValue = parseInt(element.data('oldvalue'));
			 var sum = totalSpentXps($('.habAdult'));
		 
			 //Si el total de punts gastats es major que el nombre de punts disponibles
			 if(sum > adulthoodXps){
				 previousAdulthoodSum = adulthoodXps;
				 element.val(oldValue + parseInt($('#adulthoodFreeXps').val()));
				 $('#adulthoodFreeXps').val(0);
			 } else {
				 previousAdulthoodSum = sum;
				 element.data('oldvalue',newValue);
				 $('#adulthoodFreeXps').val(adulthoodXps - sum);
			 }
			 updateTotalScore(element.data('id'));
		 } else {
			 element.val(0);
			 element.trigger('change');
		 }
		});
	 
	 $(".spinner").bind("keydown", function (event) {
		    event.preventDefault();
		});
	
	//Botons per plegar les seccions de virttus i defectes
		
	$(".toggleButton").on("click", function() {
		$(this).toggleClass("folded").toggleClass("unfolded");
		$(this).siblings(".foldableTable").slideToggle("fast");
	});
		
	//Botons per afegir un quirk a la llista de seleccionats
	
	$(".addQuirkLink").on("click", function() {
		var idQuirk = $(this).siblings("input[type=hidden].quirkId").val();
		var quirkDivision = $(this).siblings("input[type=hidden].quirkDivision").val();
		var quirkCost = ($(this).siblings("input[type=hidden].quirkType").val() == 'MAJOR' )?  3 : 1;
		
		if(quirkDivision == 'VIRTUE'){
			quirkCost += getTotalVirtuesPoints();
		} else {
			quirkCost += getTotalFlawsPoints();
		}

		if(quirkCost > 10){
			$('#dialog').html("<p>It's not possible to take more than 10 points in virtues or flaws</p>").prop('title','Error');
			
			$("#dialog").dialog({
				modal: true,
				autoOpen: true,
				buttons: {
					"Close": function() {
						$(this).dialog("close");
					}
				}
			});
		} else {
			addQuirk(idQuirk, quirkDivision);
			updateQuirkPoints();
			updateQuirksAbilitiesTables();
		}
	});
	
	//Formulari de edicio i creacio de personatges
	
	$("#cancelCharacterFormButton").bind('click',function(event){	
		$('#mainViewContainer').show();
		$('#tabs').hide();
		if(mode == 'viewing'){
			$('#mainForm').find('textarea, select, input:text, input:checkbox').removeAttr('disabled');
			$('#mainForm').find('.spinner').spinner('enable');
			$('#saveCharacterFormButton').show();
			$('#validateCharacterFormButton').show();
			$('#abilitiesBlock').find('input').removeAttr('disabled');
			resetForm($('#mainForm'));
			$(".addQuirkLink").on("click", function() {
				var idQuirk = $(this).siblings("input[type=hidden].quirkId").val();
				var quirkDivision = $(this).siblings("input[type=hidden].quirkDivision").val();
				var quirkCost = ($(this).siblings("input[type=hidden].quirkType").val() == 'MAJOR' )?  3 : 1;
				
				if(quirkDivision == 'VIRTUE'){
					quirkCost += getTotalVirtuesPoints();
				} else {
					quirkCost += getTotalFlawsPoints();
				}

				if(quirkCost > 10){
					$('#dialog').html("<p>It's not possible to take more than 10 points in virtues or flaws</p>").prop('title','Error');
					
					$("#dialog").dialog({
						modal: true,
						autoOpen: true,
						buttons: {
							"Close": function() {
								$(this).dialog("close");
							}
						}
					});
				} else {
					addQuirk(idQuirk, quirkDivision);
					updateQuirkPoints();
					updateQuirksAbilitiesTables();
				}
			});
		} else {
			resetForm($('#mainForm'));
			updateCharPoints();
			updateQuirkPoints();
		}
	});
	
	$("#saveCharacterFormButton").bind('click',function(event){
		if(mode == 'edition'){
			$('#dialog').html('<p>Are you sure you want to save this character?</p>').prop('title','Please confirm:');

			$("#dialog").dialog({
				modal: true,
				autoOpen: true,
				width:'auto',
				buttons: {
					"Continue": function() {
						ajaxSaveOrUpdateCharacter();
						$(this).dialog("close");	
					},
					"Cancel": function() {
						$(this).dialog("close");
					}
				}
			});
		} else {
			ajaxSaveOrUpdateCharacter();
		}
	});
	
	$("#validateCharacterFormButton").bind('click',function(event){
		validateCharacter(true);
	});
	 
	//Inicialitza l'estat de les llistes de quirks i habilitats
	adulthoodXps = ($('#spinnerAge').spinner("value") - 5) * 15;
	childhoodXps = 45;
	$('#childhoodFreeXps').val(childhoodXps);
	$('#adulthoodFreeXps').val(adulthoodXps);
	updateQuirksAbilitiesTables();
	
});

//Actualitza els totals de punts d'experiencia i el score

function updateTotalScore(id){
	
	var childHabXps = ($('#childHab' + id).length) ? parseInt($('#childHab' + id).val()) : 0 ;
	var adultHabXps = parseInt($('#adultHab' + id).val());
	var totalXps = childHabXps + adultHabXps;
	
	$('#totalXps' + id).val(totalXps);
	
	$('#score' + id).val(Math.floor((Math.sqrt(1 + totalXps*(8/5)) - 1)/2));
	
}

//Actualitza les llistes de virtuts, defectes i habilitats en funcio de quins virtuts i defectes tria l'usuari

function updateQuirksAbilitiesTables(){
	
	var chosenQuirks = new Array();
	
	$('#chosenVirtuesList li').each(function(){
		chosenQuirks.push($(this).find('input[type=hidden]').val());
	});
	
	$('#chosenFlawsList li').each(function(){
		chosenQuirks.push($(this).find('input[type=hidden]').val());
	});
	
	var request = $.ajax({
		type: "POST",
		url: linkGetUpdatedElementsLists,
		data: JSON.stringify(chosenQuirks),
		contentType: "application/json; charset=utf-8",
		async: false,
	    cache: false,          
	    processData:false
	});
	
	request.done(function(data) {
		$('.abilityLine.greyed').removeClass('greyed').find('input').prop('disabled',false);
		$('.quirkLine.greyed').removeClass('greyed').find('a').on("click", function() {
			var idQuirk = $(this).siblings("input[type=hidden].quirkId").val();
			var quirkDivision = $(this).siblings("input[type=hidden].quirkDivision").val();
			addQuirk(idQuirk, quirkDivision);
			updateQuirkPoints();
			updateQuirksAbilitiesTables();
		});
		$(data.nonAvailableQuirks).each(function(index){
			$('#quirk' + this.id).addClass('greyed').find('a').off('click');
		});
		$(data.nonAvailableAbilities).each(function(index){
			$('#ability' + this.id).addClass('greyed');
			$('#childHab' + this.id).val(0).prop('disabled',true);
			$('#adultHab' + this.id).val(0).trigger('change').prop('disabled',true);
		});
	});
	
	request.fail(function(jqXHR, textStatus) {
		openModalErrorDialog('Error','Database error');
	});

}

//Calcula el total de punts invertits a habilitats depenent de l'etapa

function totalSpentXps(stage){
	 var sum = 0;
	 stage.each(function(){
		 sum += parseInt($(this).val());
	 });
	return sum;
}

function getTotalVirtuesPoints(){
	
	var virtuesPoints = 0;
	
	$('#chosenVirtuesList li').each(function(){
		virtuesPoints += ($(this).find('.columnType').text() == 'MINOR')? 1 : 3;
	});
	
	return virtuesPoints;
	
}

function getTotalFlawsPoints(){
	
	var flawsPoints = 0;
	
	$('#chosenFlawsList li').each(function(){
		flawsPoints += ($(this).find('.columnType').text() == 'MINOR')? 1 : 3;
	});
	
	return flawsPoints;
	
}

//Actualitza el balanç entre virtuts i defectes

function updateQuirkPoints(){
	
	var quirkPoints = getTotalVirtuesPoints() - getTotalFlawsPoints();
	
//	$('#chosenVirtuesList li').each(function(){
//		quirkPoints += ($(this).find('.columnType').text() == 'MINOR')? 1 : 3;
//	});
//	
//	$('#chosenFlawsList li').each(function(){
//		quirkPoints -= ($(this).find('.columnType').text() == 'MINOR')? 1 : 3;
//	});
	
	$('#quirksBalance').val(quirkPoints);
	
	if(quirkPoints != 0){
		$('#quirksBalance').addClass('redText');
	} else {
		$('#quirksBalance').removeClass('redText');
	}
	
}

//Afegeix un quirk a la llista de seleccionats que li toca depenent del tipus(VIRTUE o FLAW)

function addQuirk(idQuirk, quirkDivision){
	
	var title = $('#quirk' + idQuirk + ' .quirkData').attr('title');
	var name = $('#quirk' + idQuirk + ' .columnName').text();
	var type = $('#quirk' + idQuirk + ' .columnType').text();
	
	var content = '<li id="chosenQuirk' + idQuirk + '" class="quirkLine">';
	content += '<div class="formQuirkLine">';
	content += '<div class="quirkData" title="' + title + '">';
	content += '<span class="formQuirkLineData columnName">' + name + '</span>';
	content += '<span class="formQuirkLineData columnType">' + type + '</span>';
	content += '</div>';
	content += '<div class="removeLink">';
	content += '<a class ="removeQuirkLink" href="#" >';
	content += '<img src="' + linkRemoveFromQueueIcon + '" alt="Remove"/>';
	content += '</a>';
	content += '<input type="hidden" value="' + idQuirk + '" name="chosenQuirkID"/>';
	content += '</div>';
	content += '</div>';
	content += "</li>";
	
	if(quirkDivision == 'VIRTUE'){
		$('#chosenVirtuesList').append(content);
	} else {
		$('#chosenFlawsList').append(content);
	}

	$('.removeQuirkLink').bind('click',function(){
		var idQuirk = $(this).siblings("input[type=hidden]").val();
		$('#chosenQuirk' + idQuirk).remove();
		$('#quirk' + idQuirk).show();
		updateQuirkPoints();
		updateQuirksAbilitiesTables();
	});
	
	$('#quirk' + idQuirk).hide();
	
}	
	
//Recupera les dades del formulari d'edicio de permisos per a un personatge

function getDataEditAccessform(idElement){

	var request = $.ajax({
		type: "POST",
		data: "id=" + idElement,
		url: linkGetNonOwners,
		dataType: "json"
	});

	request.done(function(data) {
		buildEditAccessform(idElement, data.userList);
	});

	request.fail(function(jqXHR, textStatus) {
		openModalErrorDialog('Error','Database error');
	});
}

//Esborrat

function deleteElement(idElement){
	
	$('#dialog').html('<p>Are you sure you want to delete this character?</p>').prop('title','Please confirm:');
	
	$("#dialog").dialog({
		modal: true,
		autoOpen: true,
		buttons: {
			"Continue": function() {
				ajaxDeleteElement(idElement);
				$(this).dialog("close");	
			},
			"Cancel": function() {
				$(this).dialog("close");
			}
		}
	});
};

function ajaxDeleteElement(idElement){
	
	var request = $.ajax({
		type: "POST",
		url: linkDeleteCharacter,
		data: "id=" + idElement,
		dataType: "json"
	});

	request.done(function(data) {
		switch (data.error) {
			case "none":
				$('#element' + idElement).remove();
	        break;
			default:
				openModalErrorDialog('Error','Database error');
		        break;
		}
	});

	request.fail(function(jqXHR, textStatus) {
		openModalErrorDialog('Error','Database error');
	});
};


function ajaxUpdateUserRights(characterId, userLines){
	
	var data = {
			userRights:[]
		};
	
	data['characterId'] = characterId;
	
	$(userLines).each(function(index){
		
		var thisUser = $(this);
		
		var jsonVariable = {};
		
		jsonVariable["id"] = thisUser.find('input[type=hidden]').val();
		jsonVariable["canRead"] = thisUser.find('input.read').prop('checked');
		jsonVariable["canWrite"] = thisUser.find('input.write').prop('checked');
		
		data.userRights.push(jsonVariable);
		
	});
	
	var request = $.ajax({
		type: "POST",
		url: linkUpdateRights,
		data: JSON.stringify(data),
		contentType: "application/json; charset=utf-8",
		async: false,
        cache: false,          
        processData:false
	});
	
	request.done(function(data) {
		switch (data.error) {
		case "none":
			window.location = linkCharactersView;
		break;
		default:
			openModalErrorDialog('Error','Database error');
	    break;
		}
	});
	
	request.fail(function(jqXHR, textStatus) {
		openModalErrorDialog('Error','Database error');
	});
	
}

//Construccio de la pantalla d'edicio de permisos

function buildEditAccessform(idElement, userList){
	
	$('#characterId').val(idElement);
	
	var newContent = '<li class="lineTitle"><span class="columnTitle columnName">Name</span>';
	newContent += '<span class="columnTitle columnRead">Read</span>';
	newContent += '<span class="columnTitle columnWrite">Write</span></li>'
	
	$(userList).each(function(index){
		var actualUser = this;
		newContent += '<li class="elementLine">';
		newContent += '<span class="columnName">' + actualUser.username + '</span>';
		newContent += '<div class="columnOwner"></div>';
		newContent += '<div class="columnRead"><input id="read_' + actualUser.id + '_' + idElement + '" type="checkbox" class="read"></div>';
		newContent += '<div class="columnWrite"><input id="write_' + actualUser.id + '_' + idElement + '" type="checkbox" class="write"></div>';
		newContent += '<div class="columnOwner"><a class ="makeUserOwnerLink" href="#"><img src="' + linkMakeOwnerIcon + '" alt="Make owner" title="Make owner"/></a>';
		newContent += '<input type="hidden" name="userId" value="' + actualUser.id + '"/>';
        newContent += '<input type="hidden" name="characterId" value="' + idElement + '"/>';
		newContent += '</div>';	
		newContent += '</li>';		
	});
	
	$('#usersTable').html(newContent);
	
	$(userList).each(function(index){
		var actualUser = this;
		$(this.characters).each(function(index){
			if(this.characterJPA.id == idElement){
				$("#read_" + actualUser.id + "_" + idElement).prop('checked',this.canRead);
				$("#write_" + actualUser.id + "_" + idElement).prop('checked',this.canWrite);
				if ($("#write_" + actualUser.id + "_" + idElement).prop('checked')){
					$("#read_" + actualUser.id + "_" + idElement).attr("disabled", true);
				}
			}
		});
	});	
	
	//Cal associar els events a les icones
	
	$("input[type=checkbox].write").change(function() {
	    if(this.checked) {
	        $('#read_' + this.id.substring(6)).addClass("greyed").prop("checked", true).attr("disabled", true);
	    } else {
	    	$('#read_' + this.id.substring(6)).removeClass("greyed").removeAttr("disabled");
	    }
	});
		
	$(".makeUserOwnerLink").on("click", function() {
		
		var data = $(this).siblings("input[type=hidden]").serialize();
		
		$('#dialog').html('<p>Are you sure you want to make this user the new owner?</p>').prop('title','Please confirm:');

		$("#dialog").dialog({
			modal: true,
			autoOpen: true,
			width:'auto',
			buttons: {
				"Continue": function() {
					makeOwner(data);
					$(this).dialog("close");	
				},
				"Cancel": function() {
					$(this).dialog("close");
				}
			}
		});
	});


}

function makeOwner(data){

	var request = $.ajax({
		type: "POST",
		url: linkMakeUserOwner,
		data: data,
		dataType: "json"
	});
	
	request.done(function(data) {
		switch (data.error) {
		case "none":
			window.location = linkCharactersView;
		break;
		default:
			openModalErrorDialog('Error','Database error');
	    break;
		}
	});
	
	request.fail(function(jqXHR, textStatus) {
		openModalErrorDialog('Error','Database error');
	});
}

//Formulari d'edicio de personatges

//Modificar el valor del camp dels punts de característiques en funcio dels canvis a les característiques

function updateCharPoints(){
	
	var charPoints = 7;
	
	$('.spinnerChar').each(function(index){
		charPoints += charToCharPoints(parseInt($(this).spinner( "value" )));
	});
	
	$('#charPoints').val(charPoints);
	
	if(charPoints < 0){
		$('#charPoints').addClass('redText');
	} else {
		$('#charPoints').removeClass('redText');
	}
	
}

function charToCharPoints(char){
	
	switch (char) {
	    case 0:
	        return 0;
	        break;
	    case 1:
	        return -1;
	        break;
	    case 2:
	        return -3;
	        break;
	    case 3:
	        return -6;
	        break;
	    case -1:
	        return 1;
	        break;
	    case -2:
	        return 3;
	        break;
	    case -3:
	        return 6;
	        break;
	}
	
}

//Crida al validador

function validateCharacter(showResult){
	
	var formFields = $('#mainForm').find('select, textarea, .spinner, input[type=checkbox], input[type=hidden], input[type=text]');
	
	var data = {
			chosenQuirks: [],
			abilities: []
		};

	$(formFields).each(function(index){

		data[$(this).attr('name')] = $(this).val();
		
	});

	$('#chosenVirtuesList li').each(function(){
		data.chosenQuirks.push($(this).find('input[type=hidden]').val());
	});
	
	$('#chosenFlawsList li').each(function(){
		data.chosenQuirks.push($(this).find('input[type=hidden]').val());
	});
	
	$('.abilityLine').each(function(){

		var id = $(this).find('input:hidden').val();
		var childHabXps = ($('#childHab' + id).length) ? $('#childHab' + id).val() : 0 ;
		var adultHabXps = $('#adultHab' + id).val();
		
		if(childHabXps != 0 &&  adultHabXps != 0){
			
			var jsonVariable = {};
			
			jsonVariable["id"] = id;
			jsonVariable["childHab"] = childHabXps;
			jsonVariable["adultHab"] = adultHabXps;
			
			data.abilities.push(jsonVariable);
		}
		
	});
	
	var request = $.ajax({
		type: "POST",
		url: linkValidateCharacter,
		data: JSON.stringify(data),
		contentType: "application/json; charset=utf-8",
		async: false,
        cache: false,          
        processData:false
	});
	
	request.done(function(data) {
		switch (data.error) {
		case "none":
			var result = $(data.validationResult);

			if(result.length > 0){			
				
				setNotValid();
				
				if (showResult){
					var text = "The following errors has been found: <br />";
					result.each(function(index){
						text += this + "<br />";
					});
					$('#dialog').html(text).prop('title', 'Errors found');;
					
					$("#dialog").dialog({
						autoOpen: true,
						width:'auto',
						buttons: {
							"Close": function() {
								$(this).dialog("close");
							}
						}
					});
				}
			} else {
				setValid();
			}
		break;
		default:
			openModalErrorDialog('Error','Database error');
	    break;
		}
	});
	
	request.fail(function(jqXHR, textStatus) {
		openModalErrorDialog('Error','Database error');
	});
	
}

//Creacio i edicio

function ajaxSaveOrUpdateCharacter(){
	
	var formFields = $('#mainForm').find('select, textarea, .spinner, input[type=checkbox], input[type=hidden], input[type=text]');
	
	var errorList = validateFields(formFields);

	if(errorList.length > 0){
		openModalErrorDialog('Error validating fields',errorList);
	} else {
	
		var data = {
				chosenQuirks: [],
				abilities: []
			};

		$(formFields).each(function(index){

			data[$(this).attr('name')] = $(this).val();
			
		});
		
		$('#chosenVirtuesList li').each(function(){
			data.chosenQuirks.push($(this).find('input[type=hidden]').val());
		});
		
		$('#chosenFlawsList li').each(function(){
			data.chosenQuirks.push($(this).find('input[type=hidden]').val());
		});
		
		$('.abilityLine').each(function(){

			var id = $(this).find('input:hidden').val();
			var childHabXps = ($('#childHab' + id).length) ? $('#childHab' + id).val() : '0' ;
			var adultHabXps = $('#adultHab' + id).val();
			
			if(childHabXps != 0 || adultHabXps != 0){
				
				var jsonVariable = {};
				
				jsonVariable["id"] = id;
				jsonVariable["childHab"] = childHabXps;
				jsonVariable["adultHab"] = adultHabXps;
				
				data.abilities.push(jsonVariable);
			}
			
		});
		
		var link = (mode === 'edition') ? linkUpdateCharacter : linkSaveNewCharacter;
		
		var request = $.ajax({
				type: "POST",
				url: link,
				data: JSON.stringify(data),
				contentType: "application/json; charset=utf-8",
				async: false,
	            cache: false,          
	            processData:false
			});
			
		request.done(function(data) {
			switch (data.error) {
			case "none":
				
				if(mode == 'creation'){
					$('#dialog').html('<p>Character created succesfully</p>').prop('title','Information');
					
					$("#dialog").dialog({
						modal: true,
						autoOpen: true
					});
				}
				
				window.location = linkCharactersView;
			break;
			case "existing_element":
				openModalErrorDialog('Error','Existing element in database');
			break;
			default:
				openModalErrorDialog('Error','Database error');
		    break;
			}
		});
		
		request.fail(function(jqXHR, textStatus) {
			openModalErrorDialog('Error','Database error');
		});
	}
	
}

//Carrega un personatge en pantalla

function getElementBtId(idElement) {
	
	var request = $.ajax({
		type: "POST",
		url: linkGetCharacter,
		data: "id=" + idElement,
		dataType: "json"
	});

	request.done(function(data) {
		loadDataInForm(data.character);
		updateCharPoints();
		updateQuirkPoints();
		updateQuirksAbilitiesTables();
		if(mode == 'viewing'){
			$('#mainForm').find('textarea, select, input:text, input:checkbox').attr('disabled','true');
			$('#mainForm').find('.spinner').spinner('disable');
			$('#saveCharacterFormButton').hide();
			$('#validateCharacterFormButton').hide();
			$('a.addQuirkLink').off('click');
			$('a.removeQuirkLink').off('click');
			$('#abilitiesBlock input').attr('disabled','true');			
		}
	});

	request.fail(function(jqXHR, textStatus) {
		openModalErrorDialog('Error','Database error');
	});
}

//Carrega les dades d'un personatge al formulari

function loadDataInForm(data){

	$('#id').val(data.id);
	$('#name').val(data.name);
	$('#description').val(data.description);
	$('#selectGender').val(data.gender);
	$('#spinnerAge').val(data.age);
	$('#spinnerIne').val(data.ine);
	$('#spinnerPer').val(data.per);
	$('#spinnerCha').val(data.cha);
	$('#spinnerCom').val(data.com);
	$('#spinnerDex').val(data.dex);
	$('#spinnerQui').val(data.qui);
	$('#spinnerSta').val(data.sta);
	$('#spinnerStr').val(data.str);
	
	$(data.quirks).each(function(){
		addQuirk(this.id, this.quirkDivision);
	});
	
	$(data.abilities).each(function(){
		$('#childHab' + this.abilityJPA.id).val(this.infancyInvestedXps);
		$('#adultHab' + this.abilityJPA.id).val(this.adultInvestedXps);
	});

	adulthoodXps = (($('#spinnerAge').spinner("value") - 5) * 15);
	 $('#adulthoodFreeXps').val(adulthoodXps - totalSpentXps($('.habAdult')));
	
	 $('.habChild').first().trigger('change');
	 $('.habAdult').first().trigger('change');
	 
	if(data.pendingRevission == true) {
		setNotValid();
	} else {
		setValid();
	}
}

function setNotValid(){
	$('#revissionResult').text('Pending revision').addClass('redText').removeClass('greenText');
}

function setValid(){
	$('#revissionResult').text('Validated').addClass('greenText').removeClass('redText');
}