$(document).ready(function() {
	
	$('#cancelFormButton').bind('click',function(event){
		window.location = linkCancel;
	});
	
	$('#saveFormButton').bind('click',function(event){
		
		$('#dialog').html('<p>Are you sure you want to update this user?</p>').prop('title','Please confirm:');
		
		$("#dialog").dialog({
			modal: true,
			autoOpen: true,
			buttons: {
				"Continue": function() {
					$(this).dialog("close");	
					updateUser();
				},
				"Cancel": function() {
					$(this).dialog("close");
				}
			}
		});
	});
	
});

function updateUser(){
	
	var formFields = $('#mainForm').find('input[type=hidden],input[type=text],input[type=password]');
	var errorList = validateFields(formFields);
	
	if($('#password').val() != $('#reppassword').val()){
		errorList += "New password and repeat password fields are not equal.";
	}
	
	if(errorList.length > 0){
		openModalErrorDialog('Error validating fields',errorList);
	} else {
	
		var dataVars = formFields.serialize();
		
		var request = $.ajax({
				type: "POST",
				url: linkUpdateUser,
				data: dataVars,
				dataType: "text"
			});
			
		request.done(function(result) {
			if(result == 'correct'){
				formFields.val("");
				window.location = linkCancel;
			} else {
				openModalErrorDialog('Error',result);
			};
		});
			
		request.fail(function(jqXHR, textStatus) {
			openModalErrorDialog('Error','Database error');
		});	
	}
	
}

