<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<!DOCTYPE html>
<html>
	<head>
		<%@ include file="../../fragments/links.jspf" %>
		<link href="<c:url value='/css/character.css'/>" rel="stylesheet" type="text/css" media="screen" />
		<script type="text/javascript" src="<c:url value='/webcontent/js/character.js'/>"></script>
	</head>
	<body>
		<script>
 			var linkSaveNewCharacter = '<c:url value="/saveNewCharacter" />'
 			var	linkDeleteCharacter = '<c:url value="/deleteCharacter" />'
			var linkCharactersView = '<c:url value="/characters" />';
			var linkGetCharacter = '<c:url value="/getCharacter" />';
			var linkValidateCharacter = '<c:url value="/validateCharacter" />';
			var linkUpdateCharacter = '<c:url value="/updateCharacter" />';
			var linkUpdateRights = '<c:url value="/updateRights" />';
			var linkGetNonOwners = '<c:url value="/getNonOwners" />';
			var linkMainView = '<c:url value="/mainView" />';
			var linkMakeUserOwner = '<c:url value="/makeUserOwner" />';
			var linkGetUpdatedElementsLists = '<c:url value="/getUpdatedElementsLists" />';

			var linkMakeOwnerIcon = '<c:url value="/img/buttons/makeOwner.png" />'
			var linkRemoveFromQueueIcon = '<c:url value="/img/buttons/removeFromQueue.png" />'
		</script>
		<%@ include file="../../fragments/header.jspf" %>
		<%@ include file="../../fragments/navBar.jspf" %>
		<%@ include file="../../fragments/errorModalDialog.jspf" %>
 		<div class="modalDialog" id="dialog" title="Pleaser confirm">
		</div>
		<div id="mainContainer">
			<div id="mainViewContainer">
				<fieldset>
					<legend>Characters</legend>
					<ul class="elementsTable">
						<li class="lineTitle"><span class="columnTitle columnName">Name</span></li>
						<c:forEach items="${characterList}" var="element">
							<c:forEach items="${element.users}" var="user">
								<c:if test="${user.userJPA.username == loggedUser}">
									<c:set var="thisUser" scope="page" value="${user}"/>
								</c:if>
							</c:forEach>
							<li id="element${element.id}" class="elementLine">
								<span class="columnName">${element.name}</span>
								<c:if test="${thisUser.owner == true || thisUser.canWrite == true || thisUser.canRead == true}">
									<a class ="viewElementLink" href="#" >
										<img src="<c:url value='/img/buttons/view.png' />" alt="View character" title="View character"/>
									</a>
								</c:if>
								<c:if test="${thisUser.owner == true || thisUser.canWrite == true}">
									<a class ="editElementLink" href="#" >
										<img src="<c:url value='/img/buttons/edit.png' />" alt="Edit character" title="Edit character"/>
									</a>
								</c:if>
								<c:if test="${thisUser.owner == true}">
									<a class ="updateAccessLink" href="#" >
										<img src="<c:url value='/img/buttons/updateAccess.png' />" alt="Update access" title="Update access"/>
									</a>
								</c:if>
								<c:if test="${thisUser.owner == true}">
									<a class ="deleteElementLink" href="#">
										<img src="<c:url value='/img/buttons/delete.png' />" alt="Delete character" title="Delete character"/>
									</a>
								</c:if>
								<input type="hidden" value="${element.id}"/>
							</li>
						</c:forEach>
					</ul>
				</fieldset>	
				<div id="lineButtons">
					<button id="newElementButton" type="button">New character...</button>
					<button id="cancelViewButton" type="button">Cancel</button>
				</div>
			</div>
			<c:if test="${thisUser.owner == true}">
				<div id="formEditAccessContainer">
					<form id="mainAccessForm">
						<input id="characterId" name="characterId" type="hidden"/>
						<fieldset>
							<legend>Access rights</legend>
							<ul class="elementsTable" id="usersTable">
							</ul>
						</fieldset>	
					</form>
					<div id="lineButtons">
						<button id="saveRightsViewButton" type="button">Save</button>
						<button id="cancelRightsViewButton" type="button">Cancel</button>
					</div>
				</div>
			</c:if>
			<div id="tabs">
			<ul>
				<li><a href="#fragment-1">Character data</a></li>
				<li><a href="#fragment-2">Quirks</a></li>
				<li><a href="#fragment-3">Abilities</a></li>
			</ul>
			<div id="fragment-1">
			<div id="formEditCreateContainer">
				<form id="mainForm">
					<input id="id" name="id" type="hidden"/>
					<div id="characterData">
						<fieldset>
							<legend>New Character</legend>
							<div id="leftBlockData">
								<div class="line">
									<div class="label">
										<label for="name">Name</label>
									</div> 
									<div class="field">
										<input id="name" name="name" type="text" maxlength="28" data-required="true"/><span class="required-field">*</span>
									</div>
								</div>
								<div class="boxSelect">
									<select id="selectGender" name="gender" data-required="true">
										<option selected value="-1">Choose gender</option>
										<option value="MALE">Male</option>
										<option value="FEMALE">Female</option>
									</select>
									<span class="required-field">*</span>
									<div id="ageField">
										<label for="spinnerAge">Age</label>
										<input id="spinnerAge" class='spinner' value="16" name="age">
									</div>
								</div>
								<div class="descriptionField">
									<span class="">Description</span>
									<textarea id="description" name="description"cols="52" rows="4"></textarea>
								</div>
								<span class="required-field-definition">* : Required fields</span>
							</div>
							<div id="rightBlockData">
								<div class="characteristicLine">
									<p>
										<label for="spinnerIne">Intelligence</label>
										<input id="spinnerIne" class='spinner spinnerChar' value="0" name="ine">
									</p>
									<p>
										<label for="spinnerPer">Perception</label>
										<input id="spinnerPer" class='spinner spinnerChar' value="0" name="per">
									</p>
								</div>
								<div class="characteristicLine">
									<p>
										<label for="spinnerCha">Charisma</label>
										<input id="spinnerCha" class='spinner spinnerChar' value="0" name="cha">
									</p>
									<p>
										<label for="spinnerCom">Communication</label>
										<input id="spinnerCom" class='spinner spinnerChar' value="0" name="com">
									</p>
								</div>
								<div class="characteristicLine">
									<p>
										<label for="spinnerQui">Quickness</label>
										<input id="spinnerQui" class='spinner spinnerChar' value="0" name="qui">
									</p>
									<p>
										<label for="spinneDex">Dexterity</label>
										<input id="spinnerDex" class='spinner spinnerChar' value="0" name="dex">
									</p>
								</div>
								<div class="characteristicLine">
									<p>
										<label for="spinnerStr">Strenght</label>
										<input id="spinnerStr" class='spinner spinnerChar' value="0" name="str">
									</p>
									<p>
										<label for="spinnerSta">Stamina</label>
										<input id="spinnerSta" class='spinner spinnerChar' value="0" name="sta">
									</p>
								</div>
								<div class="characteristicLine" id="charPointsLine">
									<label for="charPoints">Characteristic points</label>
									<input id="charPoints" value="7" readonly>
								</div>
								<div class="characteristicLine" id="revissionResultLine">
									<span id="revissionResult"></span>
								</div>
							</div>
						</fieldset>
						<div id="lineButtons">
							<button id="saveCharacterFormButton" type="button">Save</button>
							<button id="cancelCharacterFormButton" type="button">Cancel</button>
							<button id="validateCharacterFormButton" type="button">Validate</button>
						</div>
					</div>
					</form>
				</div>
			</div>
			<div id="fragment-2">
				<div id="quirkSummary">
					<input id="quirksBalance" value="0" readonly>
				</div>
				<div id="quirksBlock">
					<div class="dataBlock">
						<div class="toggleButton unfolded" ></div><p class="titleBlock">Virtues</p>
						<ul class="quirksTable quirkCategoryTable foldableTable availableQuirksTable">
							<c:forEach items="${quirkCategoryList}" var="category">
								<li class="categoryLine">
									<div class="toggleButton unfolded" ></div>
									<span class="categoryName columnName">${category.name}</span>
									<ul class="quirksTable foldableTable">								
										<c:forEach items="${category.quirks}" var="quirk">
											<c:if test="${quirk.quirkDivision == 'VIRTUE'}">
												<li id="quirk${quirk.id}" class="quirkLine">
													<c:set var="requirements" scope="page" value="No requirements"/>
													<c:if test="${not empty quirk.requiredQuirks}">
														<c:set var="requirements" value="Requires one of the following: " />
														<c:forEach items="${quirk.requiredQuirks}" var="requiredQuirk">
															<c:if test="${not requiredQuirk.negated}">
																<c:set var="requirements" value="${requirements} ${requiredQuirk.requiredQuirkJPA.name}," /> 
															</c:if>
															<c:if test="${requiredQuirk.negated}">
																<c:set var="requirements" value="${requirements} not ${requiredQuirk.requiredQuirkJPA.name}," /> 
															</c:if> 
														</c:forEach>
													</c:if>
													<div class="formQuirkLine">
														<div class="quirkData" title='<c:out value="${requirements}"/>'>
															<span class="formQuirkLineData columnName">${quirk.name}</span>
															<span class="formQuirkLineData columnType">${quirk.quirkType}</span>
														</div>
														<div class="addLink">
															<a class ="addQuirkLink" href="#" >
																<img src="<c:url value='/img/buttons/addToQueue.png' />" alt="Add to virtues"/>
															</a>
															<input type="hidden" class="quirkId" value="${quirk.id}"/>
															<input type="hidden" class="quirkDivision" value="${quirk.quirkDivision}"/>
															<input type="hidden" class="quirkType" value="${quirk.quirkType}"/>
														</div>
													</div>
												</li>
											</c:if>
										</c:forEach>						
									</ul>
								</li>
							</c:forEach>
						</ul>
					</div>
					<div id="chosenQuirksBlock">
						<div class="chosenQuirksBlock">
							<div class="toggleButton unfolded" ></div><p class="titleBlock">Chosen virtues</p>
							<ul class="foldableTable" id="chosenVirtuesList">
							</ul>
						</div>
						<div class="chosenQuirksBlock">
							<div class="toggleButton unfolded" ></div><p class="titleBlock">Chosen flaws</p>
							<ul class="foldableTable" id="chosenFlawsList">
							</ul>
						</div>
					</div>
					<div class="dataBlock">
						<div class="toggleButton unfolded" ></div><p class="titleBlock">Flaws</p>
						<ul class="quirksTable quirkCategoryTable foldableTable availableQuirksTable">
							<c:forEach items="${quirkCategoryList}" var="category">
								<li class="categoryLine">
									<div class="toggleButton unfolded" ></div>
									<span class="categoryName columnName">${category.name}</span>
									<ul class="quirksTable foldableTable">								
										<c:forEach items="${category.quirks}" var="quirk">
											<c:if test="${quirk.quirkDivision == 'FLAW'}">
												<li id="quirk${quirk.id}" class="quirkLine">
													<c:set var="requirements" scope="page" value="No requirements"/>
													<c:if test="${not empty quirk.requiredQuirks}">
														<c:set var="requirements" value="Requires one of the following: " />
														<c:forEach items="${quirk.requiredQuirks}" var="requiredQuirk">
															<c:if test="${not requiredQuirk.negated}">
																<c:set var="requirements" value="${requirements} ${requiredQuirk.requiredQuirkJPA.name}," /> 
															</c:if>
															<c:if test="${requiredQuirk.negated}">
																<c:set var="requirements" value="${requirements} not ${requiredQuirk.requiredQuirkJPA.name}," /> 
															</c:if> 
														</c:forEach>
													</c:if>
													<div class="formQuirkLine">
														<div class="quirkData" title='<c:out value="${requirements}"/>'>
															<span class="formQuirkLineData columnName">${quirk.name}</span>
															<span class="formQuirkLineData columnType">${quirk.quirkType}</span>
														</div>
														<div class="addLink">
															<a class ="addQuirkLink" href="#" >
																<img src="<c:url value='/img/buttons/addToQueue.png' />" alt="Add to flaws"/>
															</a>
															<input type="hidden" class="quirkId" value="${quirk.id}"/>
															<input type="hidden" class="quirkDivision" value="${quirk.quirkDivision}"/>
															<input type="hidden" class="quirkType" value="${quirk.quirkType}"/>
														</div>
													</div>
												</li>
											</c:if>
										</c:forEach>						
									</ul>
								</li>
							</c:forEach>
						</ul>
					</div>
				</div>
			</div>
			<div id="fragment-3">
				<div id="abilitySummary">
					<div>
						<label for="childhoodFreeXps">Free childhood xp points:</label>
						<input id="childhoodFreeXps" readonly>
					</div>
					<div id="adulthoodFreeXpsField">
						<label for="adulthoodFreeXps">Free adulthood xp points:</label>
						<input id="adulthoodFreeXps" readonly>
					</div>
				</div>
				<div id="abilitiesBlock" class="abilityblock">
					<div class="toggleButton unfolded" ></div><p class="titleBlock">Abilities</p>
					<ul class="abilitiesTable abilityCategoryTable foldableTable">
						<li class="columnTitles">
							<span class="columnName">Name</span>
							<span class="childhoodxps">Childhood</span>
							<span class="adulthoodxps">Adulthood</span>
							<span class="totalXps">XPs</span>
							<span class="finalScore">Score</span>
						</li>
						<c:forEach items="${abilityCategoryList}" var="category">
							<li class="categoryLine">
								<div class="toggleButton unfolded" ></div>
								<span class="categoryName columnName">${category.name}</span>
								<ul class="abilityTable foldableTable">								
									<c:forEach items="${category.abilities}" var="ability">
										<li id="ability${ability.id}" class="abilityLine">
											<input type="hidden" value="${ability.id}"/>
											<c:set var="requirements" scope="page" value="No requirements"/>
											<c:if test="${not empty ability.requiredQuirks}">
												<c:set var="requirements" value="Requires one of the following: " />
												<c:forEach items="${ability.requiredQuirks}" var="requiredQuirk">
													<c:if test="${not requiredQuirk.negated}">
														<c:set var="requirements" value="${requirements} ${requiredQuirk.requiredQuirkJPA.name}," /> 
													</c:if>
													<c:if test="${requiredQuirk.negated}">
														<c:set var="requirements" value="${requirements} not ${requiredQuirk.requiredQuirkJPA.name}," /> 
													</c:if> 
												</c:forEach>
											</c:if>
											<div title='<c:out value="${requirements}"/>'>
												<span class="formQuirkLineData columnName">${ability.name}</span>
												<div class="childhoodxps">
													<c:if test="${ability.infancySelectable}">
														<input id="childHab${ability.id}" type="text" maxlength="3" class="habField habChild" value="0" data-id="${ability.id}" data-oldvalue="0">
													</c:if>
												</div>
												<div class="adulthoodxps">
														<input id="adultHab${ability.id}" type="text" maxlength="3" class="habField habAdult" value="0" data-id="${ability.id}" data-oldvalue="0">
												</div>
												<div class="totalXps">
													<input id="totalXps${ability.id}" value="0" readonly>
												</div>
												<div class="finalScore">
													<input id="score${ability.id}" value="0" readonly>
												</div>
											</div>
										</li>
									</c:forEach>						
								</ul>
							</li>
						</c:forEach>
					</ul>
				</div>
			</div>
		</div>
    	</div>
  	</body>
</html>