<%@ page language="java" contentType="text/html; charset=UTF-8" pageEncoding="UTF-8"%>
<%@ taglib uri="http://java.sun.com/jsp/jstl/core" prefix="c" %>
<!DOCTYPE html>
<html>
	<head>
		<%@ include file="../../fragments/links.jspf" %>
		<link href="<c:url value='/css/userManagement.css'/>" rel="stylesheet" type="text/css" media="screen" />
		<link href="<c:url value='/css/editUser.css'/>" rel="stylesheet" type="text/css" media="screen" />
		<script type="text/javascript" src="<c:url value='/webcontent/js/editUser.js'/>"></script>
	</head>
	<body>
		<script>
			var linkUpdateUser = '<c:url value="/updateUser" />';
			var linkCancel = '<c:url value="${linkCancel}" />';
		</script>
		<%@ include file="../../fragments/header.jspf" %>
		<%@ include file="../../fragments/navBar.jspf" %>
		<%@ include file="../../fragments/errorModalDialog.jspf" %>
		<div class="modalDialog" id="dialog">
		</div>
		<div id="mainContainer">
			<div id="formEditCreateContainer">
				<form id="mainForm">
					<input name="id" type="hidden" value="${user.id}"/>
					<fieldset>
						<legend>Edit User</legend>
						<div class="line">
							<div class="label">
								<label for="username">Username</label>
							</div> 
							<div class="field">
								<input id="username" name="username" value="${user.username}" type="text" maxlength="20" data-required="true"/><span class="required-field">*</span>
							</div>
						</div>
						<div class="line">
							<div class="label">
								<label for="password">New password</label>
							</div>
							<div class="field"> 
								<input id="password" name="password" value="" type="password" maxlength="12" /></span>
							</div>
						</div>
						<div class="line">
							<div class="label">
								<label for="reppassword">Repeat password</label>
							</div>
							<div class="field"> 
								<input id="reppassword" value="" type="password" maxlength="12" /></span>
							</div>
						</div>
						<div class="line">
							<div class="label">
								<label for="email">Email</label>
							</div> 
							<div class="field">
								<input id="email" name="email" value="${user.email}" type="text" maxlength="25" data-validation="email" data-required="true"/><span class="required-field">*</span>
							</div>
						</div>
					<span class="required-field-definition">* : Required fields</span>
					</fieldset>
					<div id="lineButtons">
						<button id="saveFormButton" type="button">Save</button>
						<button id="cancelFormButton" type="button">Cancel</button>
					</div>
				</form>
			</div>
    	</div>
  	</body>
</html>